/
-- -----------------------------------------------------
-- Create secuencias
-- -----------------------------------------------------



CREATE SEQUENCE SEQ_JUGADORES MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;


CREATE SEQUENCE SEQ_EQUIPOS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;    


CREATE SEQUENCE SEQ_COMPETICIONES MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;    


CREATE SEQUENCE SEQ_CONTRATOS MINVALUE 10000 START WITH 100000
    INCREMENT BY 1 NOCACHE;        


CREATE SEQUENCE SEQ_PARTIDOS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;

CREATE SEQUENCE SEQ_REPRESENTANTES MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;   


CREATE SEQUENCE SEQ_REPRESENTANTES_LEGALES MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;       
    
 
CREATE SEQUENCE SEQ_TECNICOS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE; 


CREATE SEQUENCE SEQ_ARBITROS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE; 


CREATE SEQUENCE SEQ_TEMPORADAS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;   


CREATE SEQUENCE SEQ_ESTADISTICAS MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;      
    


CREATE SEQUENCE seq_log_table MINVALUE 1 START WITH 1
    INCREMENT BY 1 NOCACHE;    
    
/

-- -----------------------------------------------------
-- Creacion de tipos
-- -----------------------------------------------------

create or replace type est1type as object(ID_JUGADOR NUMBER,
                                          NOMBRE VARCHAR2(255 CHAR), 
                                          APELLIDOS VARCHAR2(255 CHAR), 
                                          NACIONALIDAD VARCHAR2(255 CHAR), 
                                          FEDERACION VARCHAR2(255 CHAR), 
                                          NUMERO_FEDERADO VARCHAR2(15),
                                          FECHA_NACIMIENTO DATE, 
                                          ALTURA NUMBER, 
                                          PESO NUMBER, 
                                          POSICION VARCHAR2(45 CHAR),
                                          URL_WEB VARCHAR2(255 CHAR), 
                                          URL_VIDEO VARCHAR2(255 CHAR), 
                                          ESTADO VARCHAR2(45 CHAR),
                                          ACTIVIDAD VARCHAR2(45 CHAR),
                                          GENERO VARCHAR2(45 CHAR),
                                          FECHA_FIN DATE);
/
create or replace type t_est1type as table of est1type;
/
create or replace type est2type as object(ID_EQUIPO NUMBER,
                                          NOMBRE VARCHAR2(255 CHAR),  
                                          PUNTUACION NUMBER);
/
create or replace type t_est2type as table of est2type;
/
create or replace type est3type as object(POSICION VARCHAR2(45 CHAR),
                                          ID_JUGADOR NUMBER,
                                          NOMBRE VARCHAR2(255 CHAR), 
                                          APELLIDOS VARCHAR2(255 CHAR), 
                                          MEDIA NUMBER);
/
create or replace type t_est3type as table of est3type;
/
create or replace type est4type as object(IMPORTE_TOTAL NUMBER,
                                          NUM_CONTRATOS NUMBER);
/
create or replace type t_est4type as table of est4type;
/
create or replace type est5type as object(ID_EQUIPO NUMBER,
                                          NOMBRE  VARCHAR2(255),
                                          IMPORTE_TOTAL NUMBER);
/
create or replace type t_est5type as table of est5type;
/
create or replace type est6type as object(ID_JUGADOR NUMBER,
                                          NOMBRE VARCHAR2(255 CHAR), 
                                          APELLIDOS VARCHAR2(255 CHAR));
/
create or replace type t_est6type as table of est6type;


/
-- -----------------------------------------------------
-- CREACION DE TABLAS
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Table DATABASKET.LKP_PAIS
-- -----------------------------------------------------

CREATE TABLE DATABASKET.LKP_PAIS 
(
  ID_PAIS  NUMBER(3) NOT NULL,
  DESC_PAIS VARCHAR2(255 CHAR) not null,
  IND_CONTINENTE  NUMBER DEFAULT 0 NOT NULL,  
  CONSTRAINT PK_PAIS PRIMARY KEY (ID_PAIS)
);



-- -----------------------------------------------------
-- Table DATABASKET.LKP_POISICION
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_POSICION (
  ID_POSICION NUMBER(2) NOT NULL ,
  DESC_POSICION VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_POSICION PRIMARY KEY (ID_POSICION) );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_ACTIVIDAD
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_ACTIVIDAD (
  ID_ACTIVIDAD NUMBER(2) NOT NULL ,
  DESC_ACTIVIDAD VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_ACTIVIDAD PRIMARY KEY (ID_ACTIVIDAD) );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_SUBESTADO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_SUBESTADO (
  ID_SUBESTADO NUMBER(2) NOT NULL ,
  DESC_SUBESTADO VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_SUBESTADO PRIMARY KEY (ID_SUBESTADO) );




-- -----------------------------------------------------
-- Table DATABASKET.LKP_ESTADO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_ESTADO (
  ID_ESTADO NUMBER(2) NOT NULL ,
  DESC_ESTADO VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_ESTADO PRIMARY KEY (ID_ESTADO) );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_GENERO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_GENERO (
  ID_GENERO NUMBER(2) NOT NULL ,
  DESC_GENERO VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_LKP_GENERO PRIMARY KEY (ID_GENERO) );
  
-- -----------------------------------------------------
-- Table DATABASKET.JUGADOR
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.JUGADOR (
  ID_JUGADOR NUMBER NOT NULL ,
  NACIONALIDAD VARCHAR2(255 CHAR) NOT NULL ,
  FEDERACION NUMBER(3) NOT NULL ,
  NUMERO_FEDERADO VARCHAR2(15 CHAR) NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  APELLIDOS VARCHAR2(255 CHAR) NOT NULL ,
  FECHA_NACIMIENTO DATE NOT NULL ,
  ALTURA NUMBER NOT NULL ,
  PESO NUMBER NOT NULL ,
  ID_POSICION NUMBER(2) NOT NULL ,
  URL_WEB VARCHAR2(255 CHAR) NULL ,
  URL_VIDEO VARCHAR2(255 CHAR) NULL ,
  ID_ESTADO NUMBER(2) NOT NULL ,
  ID_ACTIVIDAD NUMBER(2) NOT NULL ,
  ID_GENERO NUMBER(2) NOT NULL ,
  CONSTRAINT PK_JUGADOR PRIMARY KEY (ID_JUGADOR) ,
  CONSTRAINT FK_JUGADOR_LKP_PAIS
    FOREIGN KEY (FEDERACION )
    references DATABASKET.LKP_PAIS (ID_PAIS )
    ON DELETE CASCADE
    ,
  CONSTRAINT FK_JUGADOR_LKP_POSICION
    FOREIGN KEY (ID_POSICION )
    references DATABASKET.LKP_POSICION (ID_POSICION )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_JUGADOR_LKP_ACTIVIDAD
    FOREIGN KEY (ID_ACTIVIDAD )
    REFERENCES DATABASKET.LKP_ACTIVIDAD (ID_ACTIVIDAD )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_JUGADOR_LKP_ESTADO
    FOREIGN KEY (ID_ESTADO )
    REFERENCES DATABASKET.LKP_ESTADO (ID_ESTADO )
    on delete cascade
	,
  CONSTRAINT FK_JUGADOR_LKP_GENERO
    FOREIGN KEY (ID_GENERO )
    references DATABASKET.LKP_GENERO (ID_GENERO )
    ON DELETE CASCADE
	
    );

-- -----------------------------------------------------
-- Table DATABASKET.HIST_MEDICO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.HIST_MEDICO (
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FINAL DATE NULL ,
  ID_JUGADOR NUMBER NOT NULL ,
  ID_SUBESTADO NUMBER(2) NOT NULL ,
  DIAGNOSTICO VARCHAR2(255 CHAR) NULL ,
  CONSTRAINT PK_HIST_MEDICO PRIMARY KEY (FECHA_INICIO, ID_JUGADOR, ID_SUBESTADO) ,
   
  CONSTRAINT FK_HIST_MEDICO_LKP_SUBESTADO
    FOREIGN KEY (ID_SUBESTADO )
    references DATABASKET.LKP_SUBESTADO (ID_SUBESTADO )
    ON DELETE CASCADE
	,
        
  CONSTRAINT FK_HIST_MEDICO_JUGADOR
    FOREIGN KEY (ID_JUGADOR )
    references DATABASKET.JUGADOR (ID_JUGADOR )    
	ON DELETE CASCADE
    );

-- -----------------------------------------------------
-- Table DATABASKET.LKP_SOCIEDAD
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_SOCIEDAD (
  ID_SOCIEDAD NUMBER(2) NOT NULL ,
  DESC_SOCIEDAD VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_SOCIEDAD PRIMARY KEY (ID_SOCIEDAD) );


-- -----------------------------------------------------
-- Table DATABASKET.EQUIPO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EQUIPO (
  ID_EQUIPO NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  MUNICIPIO VARCHAR2(255 CHAR) NULL ,
  ID_PAIS NUMBER(3) NOT NULL ,
  ID_SOCIEDAD NUMBER(2) NOT NULL ,
  DIRECCION VARCHAR2(255 CHAR) NULL ,
  TELEFONO VARCHAR2(15) NULL ,
  URL VARCHAR2(255 CHAR) NULL ,
  NUM_SOCIOS NUMBER NULL ,
  CONSTRAINT PK_EQUIPO PRIMARY KEY (ID_EQUIPO) ,
  CONSTRAINT FK_EQUIPO_SOCIEDAD
    FOREIGN KEY (ID_SOCIEDAD )
    references DATABASKET.LKP_SOCIEDAD (ID_SOCIEDAD )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_EQUIPO_PAIS
    FOREIGN KEY (ID_PAIS )
    references DATABASKET.LKP_PAIS (ID_PAIS )
	ON DELETE CASCADE
    );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_MONEDA
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_MONEDA (
  ID_MONEDA NUMBER(3) NOT NULL ,
  DESC_MONEDA VARCHAR2(100 CHAR) NOT NULL ,
  VALOR_EURO NUMBER NOT NULL, --COMMENT 'Valor de cambio \nrespecto al euro' ,
  CONSTRAINT PK_MONEDA PRIMARY KEY (ID_MONEDA) );


-- -----------------------------------------------------
-- Table DATABASKET.REPRESENTANTE
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REPRESENTANTE (
  ID_REPRESENTANTE NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  CONSTRAINT PK_REPRESENTANTE PRIMARY KEY (ID_REPRESENTANTE) );


-- -----------------------------------------------------
-- Table DATABASKET.REPRESENTANTE
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REPRESENTANTE_LEGAL (
  ID_REPRESENTANTE NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  CONSTRAINT PK_REPRESENTANTE_LEGAL PRIMARY KEY (ID_REPRESENTANTE) );

-- -----------------------------------------------------
-- Table DATABASKET.TECNICO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.TECNICO (
  ID_TECNICO NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  CONSTRAINT PK_TECNICO PRIMARY KEY (ID_TECNICO) );


-- -----------------------------------------------------
-- Table DATABASKET.REL_REP_JUGADOR
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_REP_JUGADOR (
  ID_JUGADOR NUMBER NOT NULL ,
  ID_REPRESENTANTE NUMBER NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FIN DATE NULL ,
  CONSTRAINT PK_REL_REP_JUGADOR PRIMARY KEY (ID_JUGADOR, ID_REPRESENTANTE, FECHA_INICIO) ,
  CONSTRAINT FK_REL_REP_JUGADOR_JUGADOR
    FOREIGN KEY (ID_JUGADOR )
    references DATABASKET.JUGADOR (ID_JUGADOR )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_REL_REP_JUGADOR_REPRESENT
    FOREIGN KEY (ID_REPRESENTANTE )
    references DATABASKET.REPRESENTANTE (ID_REPRESENTANTE )
	ON DELETE CASCADE
    );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_AMBITO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_AMBITO (
  ID_AMBITO NUMBER(2) NOT NULL ,
  DESC_AMBITO VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_AMBITO PRIMARY KEY (ID_AMBITO) );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_MODALIDAD
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_MODALIDAD (
  ID_MODALIDAD NUMBER(2) NOT NULL ,
  DESC_MODALIDAD VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_MODALIDAD PRIMARY KEY (ID_MODALIDAD) );


-- -----------------------------------------------------
-- Table DATABASKET.ARBITRO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.ARBITRO (
  ID_ARBITRO NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  CONSTRAINT PK_ARBITRO PRIMARY KEY (ID_ARBITRO) );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_CATEGORIA
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_CATEGORIA (
  ID_CATEGORIA NUMBER(2) NOT NULL ,
  DESC_CATEGORIA VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_CATEGORIA PRIMARY KEY (ID_CATEGORIA) );


-- -----------------------------------------------------
-- Table DATABASKET.COMPETICION
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.COMPETICION (
  ID_COMPETICION NUMBER NOT NULL ,
  NOMBRE VARCHAR2(255 CHAR) NOT NULL ,
  ID_AMBITO NUMBER(2) NOT NULL,
  ID_GENERO NUMBER(2) NOT NULL,
  ID_MODALIDAD NUMBER(2) NOT NULL,
  ID_PAIS NUMBER(3) NOT NULL ,
  CONSTRAINT PK_COMPETICION PRIMARY KEY (ID_COMPETICION) ,
  CONSTRAINT FK_COMPETICION_GENERO
    FOREIGN KEY (ID_GENERO )
    REFERENCES DATABASKET.LKP_GENERO (ID_GENERO )
on delete cascade	
    ,
  CONSTRAINT FK_COMPETICION_MODALIDAD
    FOREIGN KEY (ID_MODALIDAD )
    REFERENCES DATABASKET.LKP_MODALIDAD (ID_MODALIDAD )
	on delete cascade
    ,
  CONSTRAINT FK_COMPETICION_AMBITO
    FOREIGN KEY (ID_AMBITO )
    REFERENCES DATABASKET.LKP_AMBITO (ID_AMBITO )
	on delete cascade
    ,
  CONSTRAINT FK_COMPETICION_PAIS
    FOREIGN KEY (ID_PAIS )
    references DATABASKET.LKP_PAIS (ID_PAIS )
	ON DELETE CASCADE
    );


-- -----------------------------------------------------
-- Table DATABASKET.TEMPORADA
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.TEMPORADA (
  ID_TEMPORADA NUMBER NOT NULL ,
  ID_COMPETICION	NUMBER NOT NULL,
  NOMBRE VARCHAR2(45 CHAR) ,
  ID_CATEGORIA NUMBER(2) NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FIN DATE NOT NULL ,
  PONDERACION NUMBER,
  constraint PK_TEMPORADA primary key (ID_TEMPORADA) ,
  --CONSTRAINT PK_TEMPORADA_COMPETICION PRIMARY KEY (ID_COMPETICION,ID_CATEGORIA, FECHA_INICIO) ,
  CONSTRAINT FK_TEMPORADA_CATEGORIA
    FOREIGN KEY (ID_CATEGORIA )
    references DATABASKET.LKP_CATEGORIA (ID_CATEGORIA )
    ON DELETE CASCADE
	,
  CONSTRAINT FK_TEMPORADA_COMPETICION
    FOREIGN KEY (ID_COMPETICION )
    references DATABASKET.COMPETICION (ID_COMPETICION )
	ON DELETE CASCADE
    );


-- -----------------------------------------------------
-- Table DATABASKET.REL_EQUIPO_COMPETICION
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_EQUIPO_TEMPORADA (
  ID_EQUIPO NUMBER NOT NULL ,
  ID_TEMPORADA NUMBER NOT NULL ,
  CONSTRAINT PK_REL_EQUIPO_TEMPORADA PRIMARY KEY (ID_EQUIPO, ID_TEMPORADA) ,
  CONSTRAINT FK_REL_EQUIP_TEMP_EQUIPO
    FOREIGN KEY (ID_EQUIPO )
    references DATABASKET.EQUIPO (ID_EQUIPO )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_REL_EQUIP_TEMP_TEMP
    FOREIGN KEY (ID_TEMPORADA )
    REFERENCES DATABASKET.TEMPORADA (ID_TEMPORADA )
	on delete cascade
    );


-- -----------------------------------------------------
-- Table DATABASKET.PARTIDO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.PARTIDO (
  ID_PARTIDO NUMBER NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  ID_EQUIPO_LOCAL NUMBER NOT NULL ,
  ID_EQUIPO_VISITANTE NUMBER NOT NULL ,
  ID_TEMPORADA NUMBER NOT NULL ,
  CONSTRAINT PK_PARTIDO PRIMARY KEY (ID_PARTIDO) ,
  CONSTRAINT FK_PARTIDO_TEMP_VISIT
    FOREIGN KEY (ID_TEMPORADA, ID_EQUIPO_VISITANTE )
    REFERENCES DATABASKET.REL_EQUIPO_TEMPORADA (ID_TEMPORADA, ID_EQUIPO )
	on delete cascade
    ,
  CONSTRAINT FK_PARTIDO_TEMP_LOCAL
    FOREIGN KEY (ID_TEMPORADA, ID_EQUIPO_LOCAL )
    REFERENCES DATABASKET.REL_EQUIPO_TEMPORADA (ID_TEMPORADA, ID_EQUIPO )
	on delete cascade
    );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_ROL_ARBITRO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_ROL_ARBITRO (
  ID_ROL NUMBER(2) NOT NULL ,
  DESC_ROL VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_ROL_ARBITRO PRIMARY KEY (ID_ROL) );


-- -----------------------------------------------------
-- Table DATABASKET.REL_ARB_PARTIDO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_ARB_PARTIDO (
  ID_ARBITRO NUMBER NOT NULL ,
  ID_PARTIDO NUMBER NOT NULL ,
  ID_ROL NUMBER(2) NOT NULL ,
  CONSTRAINT PK_REL_ARB_PARTIDO PRIMARY KEY (ID_ARBITRO, ID_PARTIDO, ID_ROL) ,
  CONSTRAINT FK_REL_ARB_PARTIDO_ARBITRO
    FOREIGN KEY (ID_ARBITRO )
    REFERENCES DATABASKET.ARBITRO (ID_ARBITRO )
	on delete cascade
    ,
  CONSTRAINT FK_REL_ARB_PARTIDO_PARTIDO
    FOREIGN KEY (ID_PARTIDO )
    references DATABASKET.PARTIDO (ID_PARTIDO )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_REL_ARB_PARTIDO_ROL
    FOREIGN KEY (ID_ROL )
    references DATABASKET.LKP_ROL_ARBITRO (ID_ROL )
	ON DELETE CASCADE
    );


-- -----------------------------------------------------
-- Table DATABASKET.CONTRATO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.CONTRATO (
  ID_CONTRATO NUMBER NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FIN DATE,
  ID_EQUIPO_COMPRADOR NUMBER NOT NULL ,
  ID_EQUIPO_VENDEDOR NUMBER,
  COMPENSACION NUMBER  NOT NULL,
  SALARIO NUMBER  NOT NULL,
  IMPORTE NUMBER,
  ID_MONEDA NUMBER(3) NOT NULL ,
  ID_JUGADOR NUMBER NOT NULL ,
  constraint PK_CONTRATO primary key (ID_CONTRATO),
  --CONSTRAINT PK_CONTRATO_VENTA PRIMARY KEY (ID_JUGADOR, ID_EQUIPO_COMPRADOR, FECHA_INICIO) ,
  CONSTRAINT FK_CONTRATO_JUGADOR
    FOREIGN KEY (ID_JUGADOR )
    REFERENCES DATABASKET.JUGADOR (ID_JUGADOR )
	on delete cascade,
  CONSTRAINT FK_CONTRATO_EQUIPO_COMP
    FOREIGN KEY (ID_EQUIPO_COMPRADOR )
    REFERENCES DATABASKET.EQUIPO (ID_EQUIPO )
	on delete cascade,
  CONSTRAINT FK_CONTRATO_MONEDA
    FOREIGN KEY (ID_MONEDA )
    REFERENCES DATABASKET.LKP_MONEDA (ID_MONEDA )
	on delete cascade
    );


-- -----------------------------------------------------
-- Table DATABASKET.LKP_ROL_TECNICO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.LKP_ROL_TECNICO (
  ID_ROL NUMBER(2) NOT NULL ,
  DESC_ROL VARCHAR2(45 CHAR) NOT NULL ,
  CONSTRAINT PK_ROL_TECNICO PRIMARY KEY (ID_ROL) );

-- -----------------------------------------------------
-- Table DATABASKET.REL_JUGADOR_PARTIDO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_JUGADOR_PARTIDO (
  ID_JUGADOR NUMBER NOT NULL ,
  ID_PARTIDO NUMBER NOT NULL ,
  CONSTRAINT PK_REL_JUG_PAR PRIMARY KEY ( ID_JUGADOR, ID_PARTIDO) ,
  CONSTRAINT FK_REL_JUG_PAR_JUG
    FOREIGN KEY (ID_JUGADOR )
    REFERENCES DATABASKET.JUGADOR (ID_JUGADOR )
	on delete cascade
    ,
  CONSTRAINT FK_REL_JUG_PAR_PAR
    FOREIGN KEY (ID_PARTIDO )
    references DATABASKET.PARTIDO (ID_PARTIDO )
	ON DELETE CASCADE
    );

-- -----------------------------------------------------
-- Table DATABASKET.ESTADISTICA
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.ESTADISTICA (
  ID_ESTADISTICA NUMBER NOT NULL ,
  MIN_JUGADOS NUMBER DEFAULT 0,
  PUNTOS	NUMBER DEFAULT 0,
  T_LIBRE_OK NUMBER DEFAULT 0,
  T_LIBRE NUMBER DEFAULT 0,
  T_DOS_OK NUMBER DEFAULT 0,
  T_DOS NUMBER DEFAULT 0,
  T_TRES_OK NUMBER DEFAULT 0,
  T_TRES NUMBER DEFAULT 0,
  REBOTES_DEFENSIVOS NUMBER DEFAULT 0,
  REBOTES_OFENSIVOS NUMBER DEFAULT 0,
  ASISTENCIAS NUMBER DEFAULT 0,
  TAP_REALIZADOS NUMBER DEFAULT 0,
  TAP_RECIBIDOS NUMBER DEFAULT 0 ,
  RECUPERACIONES NUMBER DEFAULT 0,
  PERDIDAS NUMBER DEFAULT 0 ,
  FAL_RECIBIDAS NUMBER DEFAULT 0 ,
  FAL_REALIZADAS NUMBER DEFAULT 0 ,
  VALORACION NUMBER, 
  VALORACION_PONDERADA number, 
  constraint PK_ESTADISTICA primary key (ID_ESTADISTICA)
  
  );


-- -----------------------------------------------------
-- Table DATABASKET.REL_EST_JUG_PAR
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_EST_JUG_PAR (
  ID_ESTADISTICA NUMBER NOT NULL ,
  ID_JUGADOR NUMBER NOT NULL ,
  ID_PARTIDO NUMBER NOT NULL ,
  CONSTRAINT PK_REL_EST_JUG_PAR PRIMARY KEY (ID_ESTADISTICA, ID_JUGADOR, ID_PARTIDO) ,

CONSTRAINT FK_REL_EST_JUG_PAR_EST
    foreign key (ID_ESTADISTICA)
    references DATABASKET.ESTADISTICA (ID_ESTADISTICA )
	on delete cascade
    ,
  CONSTRAINT FK_REL_EST_JUG_PAR_JUG
    FOREIGN KEY (ID_JUGADOR )
    references DATABASKET.JUGADOR (ID_JUGADOR )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_REL_EST_JUG_PAR_PAR
    FOREIGN KEY (ID_PARTIDO )
    references DATABASKET.PARTIDO (ID_PARTIDO )
	ON DELETE CASCADE
    );




-- -----------------------------------------------------
-- Table DATABASKET.REL_TEC_EQUIPO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_TEC_EQUIPO (
  ID_EQUIPO NUMBER NOT NULL ,
  ID_TECNICO NUMBER NOT NULL ,
  ID_ROL NUMBER(2) NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FIN DATE ,
  CONSTRAINT PK_REL_TEC_EQUIPO PRIMARY KEY (ID_EQUIPO, ID_TECNICO, ID_ROL, FECHA_INICIO) ,
  CONSTRAINT FK_REL_TEC_EQUIPO_EQUIPO
    FOREIGN KEY (ID_EQUIPO )
    references DATABASKET.EQUIPO (ID_EQUIPO )
	ON DELETE CASCADE
    ,
  CONSTRAINT FK_REL_TEC_EQUIPO_TECNICO
    FOREIGN KEY (ID_TECNICO )
    REFERENCES DATABASKET.TECNICO (ID_TECNICO )
	on delete cascade
    ,
  CONSTRAINT FK_REL_TEC_EQUIPO_ROL
    FOREIGN KEY (ID_ROL )
    REFERENCES DATABASKET.LKP_ROL_TECNICO (ID_ROL )
	on delete cascade
    );


-- -----------------------------------------------------
-- Table DATABASKET.REL_REP_EQUIPO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.REL_REP_EQUIPO (
  ID_EQUIPO NUMBER NOT NULL ,
  ID_REPRESENTANTE NUMBER NOT NULL ,
  FECHA_INICIO DATE NOT NULL ,
  FECHA_FIN DATE NULL ,
  CONSTRAINT PK_REL_EQUIPO_REP PRIMARY KEY (ID_EQUIPO, ID_REPRESENTANTE, FECHA_INICIO) ,
  CONSTRAINT FK_REL_REP_EQUIPO_EQUIPO
    FOREIGN KEY (ID_EQUIPO )
    REFERENCES DATABASKET.EQUIPO (ID_EQUIPO )
	on delete cascade
    ,
  CONSTRAINT FK_REL_REP_EQUIPO_REP
    FOREIGN KEY (ID_REPRESENTANTE )
    REFERENCES DATABASKET.REPRESENTANTE_LEGAL (ID_REPRESENTANTE )
	on delete cascade
    );


-- -----------------------------------------------------
-- Table DATABASKET.EST_JUGADORES_ACTIVOS
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EST_JUGADORES_ACTIVOS (
  ID_GENERO NUMBER(2) NOT NULL ,
  ID_MODALIDAD NUMBER(2) NOT NULL ,
  TOTAL NUMBER DEFAULT 0
	
  );


-- -----------------------------------------------------
-- Table DATABASKET.EST_MAXIMO_ANOTADOR
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EST_MAXIMO_ANOTADOR (
  ID_JUGADOR NUMBER NOT NULL ,
  ID_COMPETICION NUMBER NOT NULL 
  );


-- -----------------------------------------------------
-- Table DATABASKET.EST_MEJOR_PAGADO
-- -----------------------------------------------------


CREATE  TABLE DATABASKET.EST_MEJOR_PAGADO (
  ID_JUGADOR NUMBER NOT NULL ,
  ID_MODALIDAD NUMBER(2) NOT NULL ,
  ID_GENERO NUMBER(2) NOT NULL,
  TOTAL     NUMBER NULL
  );


-- -----------------------------------------------------
-- Table DATABASKET.EST_MAYOR_GANANCIA
-- -----------------------------------------------------


CREATE  TABLE DATABASKET.EST_MAYOR_GANANCIA (
  ID_JUGADOR NUMBER NOT NULL,
  TOTAL      NUMBER NULL
 );


-- -----------------------------------------------------
-- Table DATABASKET.EST_SUELDO_MEDIO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EST_SUELDO_MEDIO (
  ID_PAIS NUMBER(3) NOT NULL ,
  ID_TEMPORADA number not null,
  ID_GENERO number(2) not null ,
  ID_MODALIDAD NUMBER(2) NOT NULL,
  SUELDO_MEDIO NUMBER);


-- -----------------------------------------------------
-- Table DATABASKET.EST_MEJORES_EQUIPO
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EST_MEJORES_EQUIPOS (
  ID_COMPETICION number not null ,
  ID_TEMPORADA  number not null,
  ID_EQUIPO_ATACANTE number not null,
  ID_EQUIPO_DEFENSOR NUMBER not null);


-- -----------------------------------------------------
-- Table DATABASKET.EST_MEJOR_JUGADOR
-- -----------------------------------------------------

CREATE  TABLE DATABASKET.EST_MEJOR_JUGADOR (
  ID_GENERO NUMBER NOT NULL ,
  ID_MODALIDAD NUMBER NULL ,
  ID_JUGADOR number null);


CREATE TABLE DATABASKET.LOG_TABLE
  (
    "ID_LOG" NUMBER,
    "FCH_TIMESTAMP" DATE,
    "ID_PROC"      VARCHAR2(50 CHAR),
    "DESC_MESSAGE" VARCHAR2(250 CHAR),
    "SQLERR"       NUMBER,
    "SQLTEXT"      VARCHAR2(200 CHAR),
    "SQLCMD"       VARCHAR2(4000 CHAR),
    "ID_LOG_LEVEL" VARCHAR2(10 CHAR),
    
      CONSTRAINT PK_LOG_TABLE PRIMARY KEY (ID_LOG)
  );
  
   CREATE INDEX DATABASKET.LOG_TABLE_INDEX1 ON DATABASKET.LOG_TABLE (ID_LOG, ID_LOG_LEVEL) ;

CREATE TABLE DATABASKET.LKP_ERRORES
  (
    "ID_ERROR" NUMBER,
    "DESC_ERROR" VARCHAR2(255 CHAR),
    
    CONSTRAINT PK_LKP_ERRORES PRIMARY KEY (ID_ERROR)
  );

/*
Create OR REPLACE view VLK_PARTIDOS_TEMPORADA
 AS select tem.id_competicion, Tem.id_temporada,  par.id_partido
          FROM temporada tem, partido par
          where par.id_temporada = tem.id_temporada
          group by tem.id_competicion, Tem.id_temporada,  par.id_partido
          ;
*/

Create OR REPLACE view VLK_JUGADORES_TEMPORADA
AS
select com.id_competicion, tem.id_temporada, jug.id_jugador, rel.id_equipo
          from competicion com, temporada tem, rel_equipo_temporada rel, contrato con, jugador jug
          where tem.id_competicion = com.id_competicion
          and rel.id_temporada = tem.id_temporada
          and con.id_equipo_comprador = rel.id_equipo
          AND ( 
               (con.fecha_fin BETWEEN tem.fecha_inicio AND tem.fecha_fin) 
              OR 
              (con.fecha_inicio BETWEEN tem.fecha_inicio AND tem.fecha_fin ) 
             OR 
             (con.fecha_inicio <= tem.fecha_inicio AND con.fecha_fin >= tem.fecha_fin) )
          AND con.id_jugador = jug.id_jugador
          group by com.id_competicion, tem.id_temporada, jug.id_jugador, rel.id_equipo
          order by jug.id_jugador
          ;       

CREATE OR REPLACE VIEW vlk_resultado_partidos
AS
SELECT par.id_partido,jtem.id_equipo, sum(est.puntos) puntos
FROM estadistica est, rel_est_jug_par rel, partido par, vlk_jugadores_temporada jtem
WHERE rel.id_estadistica = est.id_estadistica
AND par.id_partido = rel.id_partido
AND jtem.id_equipo in (par.id_equipo_local, par.id_equipo_visitante) 
AND rel.id_jugador = jtem.id_jugador
AND par.id_temporada = jtem.id_temporada
GROUP BY  par.id_partido, jtem.id_equipo
ORDER BY id_partido
;          

/

--- Inserccion de valores generales


INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES (1, 'Africa', 1 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (2, 'America', 1 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (3, 'Asia', 1 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (4, 'Europa', 1 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (5, 'Oceania', 1 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (6, 'Afganistan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (7, 'Africa del Sur', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (8, 'Albania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (9, 'Alemania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (10, 'Andorra', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (11, 'Angola', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (12, 'Antigua y Barbuda', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (13, 'Antillas Holandesas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (14, 'Arabia Saudita', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (15, 'Argelia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (16, 'Argentina', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (17, 'Armenia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (18, 'Aruba', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (19, 'Australia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (20, 'Austria', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (21, 'Azerbaijan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (22, 'Bahamas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (23, 'Bahrain', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (24, 'Bangladesh', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (25, 'Barbados', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (26, 'Belarusia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (27, 'Belgica', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (28, 'Belice', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (29, 'Benin', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (30, 'Bermudas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (31, 'Bolivia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (32, 'Bosnia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (33, 'Botswana', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (34, 'Brasil', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (35, 'Brunei Darussulam', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (36, 'Bulgaria', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (37, 'Burkina Faso', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (38, 'Burundi', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (39, 'Butan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (40, 'Camboya', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (41, 'Camerun', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (42, 'Canada', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (43, 'Cape Verde', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (44, 'Chad', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (45, 'Chile', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (46, 'China', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (47, 'Chipre', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (48, 'Colombia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (49, 'Comoros', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (50, 'Congo', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (51, 'Corea del Norte', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (52, 'Corea del Sur', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (53, 'Costa de Marfíl', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (54, 'Costa Rica', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (55, 'Croasia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (56, 'Cuba', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (57, 'Dinamarca', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (58, 'Djibouti', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (59, 'Dominica', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (60, 'Ecuador', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (61, 'Egipto', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (62, 'El Salvador', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (63, 'Emiratos Arabes Unidos', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (64, 'Eritrea', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (65, 'Eslovenia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (66, 'España', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (67, 'Estados Unidos', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (68, 'Estonia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (69, 'Etiopia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (70, 'Fiji', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (71, 'Filipinas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (72, 'Finlandia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (73, 'Francia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (74, 'Gabon', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (75, 'Gambia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (76, 'Georgia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (77, 'Ghana', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (78, 'Granada', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (79, 'Grecia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (80, 'Groenlandia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (81, 'Guadalupe', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (82, 'Guam', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (83, 'Guatemala', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (84, 'Guayana Francesa', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (85, 'Guerney', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (86, 'Guinea', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (87, 'Guinea-Bissau', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (88, 'Guinea Equatorial', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (89, 'Guyana', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (90, 'Haiti', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (91, 'Holanda', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (92, 'Honduras', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (93, 'Hong Kong', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (94, 'Hungria', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (95, 'India', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (96, 'Indonesia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (97, 'Irak', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (98, 'Iran', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (99, 'Irlanda', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (100, 'Islandia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (101, 'Islas Caiman', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (102, 'Islas Faroe', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (103, 'Islas Malvinas (Falkland Islands)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (104, 'Islas Marshall', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (105, 'Islas Solomon', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (106, 'Islas Virgenes (U.S.)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (107, 'Israel', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (108, 'Italia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (109, 'Jamaica', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (110, 'Japon', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (111, 'Jersey', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (112, 'Jordania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (113, 'Kazakhstan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (114, 'Kenia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (115, 'Kiribati', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (116, 'Kuwait', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (117, 'Kyrgyzstan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (118, 'Laos', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (119, 'Latvia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (120, 'Lesotho', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (121, 'Libano', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (122, 'Liberia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (123, 'Libia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (124, 'Liechtenstein', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (125, 'Lituania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (126, 'Luxemburgo', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (127, 'Macao', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (128, 'Macedionia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (129, 'Madagascar', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (130, 'Malasia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (131, 'Malawi', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (132, 'Maldivas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (133, 'Mali', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (134, 'Malta', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (135, 'Marruecos', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (136, 'Martinica', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (137, 'Mauricio', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (138, 'Mauritania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (139, 'Mexico', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (140, 'Micronesia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (141, 'Moldova', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (142, 'Monaco', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (143, 'Mongolia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (144, 'Mozambique', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (145, 'Myanmar (Burma)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (146, 'Namibia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (147, 'Nepal', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (148, 'Nicaragua', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (149, 'Niger', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (150, 'Nigeria', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (151, 'Noruega', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (152, 'Nueva Caledonia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (153, 'Nueva Zealandia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (154, 'Oman', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (155, 'Pakistan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (156, 'Palestina', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (157, 'Panama', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (158, 'Papua Nueva Guinea', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (159, 'Paraguay', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (160, 'Peru', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (161, 'Polinesia Francesa', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (162, 'Polonia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (163, 'Portugal', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (164, 'Puerto Rico', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (165, 'Qatar', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (166, 'Reino Unido', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (167, 'Republica Centroafricana', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (168, 'Republica Checa', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (169, 'Republica Democratica del Congo', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (170, 'Republica Dominicana', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (171, 'Republica Eslovaca', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (172, 'Reunion', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (173, 'Ruanda', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (174, 'Rumania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (175, 'Rusia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (176, 'Sahara', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (177, 'Samoa', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (178, 'San Cristobal-Nevis (St. Kitts)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (179, 'San Marino', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (180, 'San Vincente y las Granadinas', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (181, 'Santa Lucia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (182, 'Santa Sede (Vaticano)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (183, 'Sao Tome '||'&'||' Principe', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (184, 'Senegal', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (185, 'Seychelles', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (186, 'Sierra Leona', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (187, 'Singapur', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (188, 'Siria', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (189, 'Somalia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (190, 'Sri Lanka (Ceilan)', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (191, 'Sudan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (192, 'Sudan del Sur', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (193, 'Suecia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (194, 'Suiza', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (195, 'Sur Africa', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (196, 'Surinam', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (197, 'Swaziland', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (198, 'Tailandia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (199, 'Taiwan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (200, 'Tajikistan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (201, 'Tanzania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (202, 'Timor Oriental', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (203, 'Togo', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (204, 'Tonga', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (205, 'Trinidad '||'&'||' Tobago', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (206, 'Tunisia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (207, 'Turkmenistan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (208, 'Turquia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (209, 'Ucrania', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (210, 'Uganda', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (211, 'Union Europea', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (212, 'Uruguay', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (213, 'Uzbekistan', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (214, 'Vanuatu', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (215, 'Venezuela', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (216, 'Vietnam', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (217, 'Yemen', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (218, 'Yugoslavia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (219, 'Zambia', 0 );
INSERT INTO LKP_PAIS (ID_PAIS, DESC_PAIS, IND_CONTINENTE) VALUES  (220, 'Zimbabwe', 0 );

COMMIT;

INSERT INTO "DATABASKET"."LKP_POSICION" (ID_POSICION, DESC_POSICION) VALUES ('1', 'Base');
INSERT INTO "DATABASKET"."LKP_POSICION" (ID_POSICION, DESC_POSICION) VALUES ('2', 'Escolta');
INSERT INTO "DATABASKET"."LKP_POSICION" (ID_POSICION, DESC_POSICION) VALUES ('3', 'Ala');
INSERT INTO "DATABASKET"."LKP_POSICION" (ID_POSICION, DESC_POSICION) VALUES ('4', 'Ala-pivot');
INSERT INTO "DATABASKET"."LKP_POSICION" (ID_POSICION, DESC_POSICION) VALUES ('5', 'Pivot');

COMMIT;

INSERT INTO "DATABASKET"."LKP_ACTIVIDAD" (ID_ACTIVIDAD, DESC_ACTIVIDAD) VALUES ('1', 'Activo');
INSERT INTO "DATABASKET"."LKP_ACTIVIDAD" (ID_ACTIVIDAD, DESC_ACTIVIDAD) VALUES ('2', 'Retirado');

INSERT INTO "DATABASKET"."LKP_ESTADO" (ID_ESTADO, DESC_ESTADO) VALUES ('1', 'ALTA');
INSERT INTO "DATABASKET"."LKP_ESTADO" (ID_ESTADO, DESC_ESTADO) VALUES ('2', 'BAJA');


INSERT INTO "DATABASKET"."LKP_GENERO" (ID_GENERO, DESC_GENERO) VALUES ('1', 'MASCULINO');
INSERT INTO "DATABASKET"."LKP_GENERO" (ID_GENERO, DESC_GENERO) VALUES ('2', 'FEMENINO');

INSERT INTO "DATABASKET"."LKP_SOCIEDAD" (ID_SOCIEDAD, DESC_SOCIEDAD) VALUES ('1', 'CLUB');
INSERT INTO "DATABASKET"."LKP_SOCIEDAD" (ID_SOCIEDAD, DESC_SOCIEDAD) VALUES ('2', 'SOCIEDAD');

commit;

INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (1, 'Euro', 1.00000);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (2, 'Dólar estadounidense', 0.76743);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (3, 'Libra esterlina', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (4, 'Rupia india', 0.01411);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (5, 'Dólar australiano', 0.78896);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (6, 'Dólar canadiense', 0.75423);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (7, 'Dírham de los EAU', 0.20894);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (8, 'Franco suizo', 0.81403);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (9, 'Yuan renminbi chino', 0.12451);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (10, 'Ringgit malasio', 0.25301);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (11, 'Yen japonés', 0.00783);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (12, 'Baht tailandés', 0.02621);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (13, 'Dólar neozelandés', 0.65074);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (14, 'Dólar singapurense', 0.62057);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (15, 'Peso filipino', 0.01862);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (16, 'Lira turca', 0.42704);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (17, 'Riyal de Arabia Saudita', 0.20468);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (18, 'Corona sueca', 0.11676);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (19, 'Dólar de Hong Kong', 0.09886);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (20, 'Peso mexicano', 0.06311);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (21, 'Rand sudafricano', 0.08426);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (22, 'Florín húngaro', 0.00331);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (23, 'Rupia indonesia', 0.00008);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (24, 'Libra egipcia', 0.11080);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (25, 'Corona noruega', 0.13116);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (26, 'Real brasilero', 0.38408);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (27, 'Corona danesa', 0.13412);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (28, 'Dinar kuwaití', 2.70032);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (29, 'Rublo ruso', 0.02454);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (30, 'Riyal catarí', 0.21085);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (31, 'Rupia pakistaní', 0.00780);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (32, 'Won surcoreano', 0.00069);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (33, 'Rial de Omán', 1.99644);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (34, 'Zloty polaco', 0.24023);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (35, 'Peso colombiano', 0.00042);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (36, 'Corona checa', 0.03883);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (37, 'Shequel israelí', 0.21299);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (38, 'Peso argentino', 0.14838);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (39, 'Peso chileno', 0.00162);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (40, 'Rupia de Sri Lanka', 0.00605);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (41, 'Dírham marroquí', 0.08984);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (42, 'Naira nigeriana', 0.00482);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (43, 'Nuevo dólar taiwanés', 0.02595);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (44, 'Dinar iraquí', 0.00066);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (45, 'Taka bengalí', 0.00985);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (46, 'Dinar bareiní', 2.03562);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (47, 'Chelín keniano', 0.00917);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (48, 'Dong vietnamita', 0.00004);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (49, 'Franco CFA', 0.00152);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (50, 'Dinar de Jordania', 1.08547);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (51, 'Dinar tunisio', 0.47661);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (52, 'Cedi ghanés', 0.39065);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (53, 'Nuevo leu rumano', 0.23030);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (54, 'Leva búlgara', 0.51129);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (55, 'Kuna croata', 0.13157);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (56, 'Nuevo sol peruano', 0.29330);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (57, 'Franco CFA BEAC centroafricano', 0.00152);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (58, 'Onza de oro', 1120.78969);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (59, 'Corona islándica', 0.00654);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (60, 'Grivna ucraniana', 0.09424);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (61, 'Dólar fiyiano', 0.42933);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (62, 'Dinar argelino', 0.00992);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (63, 'Peso dominicano', 0.01876);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (64, 'Rupia nepalesa', 0.00886);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (65, 'Franco CFP', 0.00838);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (66, 'Rupia de Mauricio', 0.02485);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (67, 'Nuevo manat azerbaiyano', 0.97799);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (68, 'Marco convertible bosnio', 0.51129);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (69, 'Dólar jamaiquino', 0.00781);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (70, 'Chelín ugandés', 0.00030);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (71, 'Bolívar venezolano', 0.12212);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (72, 'Colón costarricense', 0.00154);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (73, 'Litas lituano', 0.28962);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (74, 'Dinar serbio', 0.00901);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (75, 'Lat letón', 1.42698);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (76, 'Rial iraní', 0.00006);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (77, 'Dólar de Brunéi', 0.62057);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (78, 'Chelín tanzano', 0.00048);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (79, 'Birr Etíope', 0.04131);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (80, 'Afganí afgano', 0.01441);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (81, 'Dólar del Caribe Oriental', 0.28423);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (82, 'Pula botsuanés', 0.09340);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (83, 'Lari georgiano', 0.46458);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (84, 'Dólar de Trinidad', 0.12010);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (85, 'Onza de plata', 18.40912);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (86, 'Peso convertible cubano', 0.76743);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (87, 'Dólar zimbabuense', 0.00212);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (88, 'Quetzal guatemalteco', 0.09851);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (89, 'Kyat birmano', 0.00087);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (90, 'Dinar macedonio', 0.01645);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (91, 'Dólar de Barbados o Baja', 0.38372);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (92, 'Boliviano de Bolivia', 0.11026);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (93, 'Dinar libio', 0.60073);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (94, 'Tenge kazajo', 0.00508);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (95, 'Lek albanés', 0.00711);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (96, 'Metical mozambiqueño', 0.02516);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (97, 'Dólar de Namibia', 0.08426);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (98, 'Kwacha zambiano', 0.00014);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (99, 'Riel camboyano', 0.00019);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (100, 'Kwacha zambiano', 0.14295);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (101, 'Pataca de Macao', 0.09598);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (102, 'Libra libanesa', 0.00051);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (103, 'Kip laosiano', 0.00010);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (104, 'Dram armenio', 0.00187);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (105, 'Peso uruguayo', 0.04093);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (106, 'Kwanza angoleño', 0.00799);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (107, 'Kina de Papúa Nueva Guinea', 0.35072);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (108, 'Ariary malgache', 0.00035);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (109, 'Rublo bielorruso', 0.00009);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (110, 'Florín holandés', 0.42897);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (111, 'Vatu de Ni-Vanuatu', 0.00845);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (112, 'Libra siria', 0.01097);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (113, 'Libra sudanesa', 0.17442);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (114, 'Kwacha malawiano', 0.00196);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (115, 'Tugrik mongol', 0.00054);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (116, 'Franco ruandés', 0.00122);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (117, 'Won norcoreano', 0.00583);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (118, 'Dalasi gambiano', 0.02258);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (119, 'Guaraní paraguayo', 0.00019);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (120, 'Lempira hondureño', 0.03972);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (121, 'Peso cubano', 0.02896);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (122, 'Rupia de las Seychelles', 0.06613);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (123, 'Rufiyaa maldiva', 0.05062);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (124, 'Franco congolés', 0.00085);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (125, 'Florín holandés o de Aruba', 0.42873);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (126, 'Franco de Yibuti', 0.00439);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (127, 'Dólar guyanés', 0.00380);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (128, 'Córdoba nicaragüense', 0.03141);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (129, 'Dólar de las Caimanes', 0.93589);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (130, 'Rial yemení', 0.00358);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (131, 'Gourde haitiano', 0.01806);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (132, 'Tala samoano', 0.33306);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (133, 'Dólar de Belice', 0.39161);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (134, 'Dólar bahameño', 0.76743);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (135, 'Franco de Guinea', 0.00011);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (136, 'Escudo caboverdiano', 0.00909);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (137, 'Paanga tonganés', 0.44043);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (138, 'Leu moldavo', 0.06265);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (139, 'Leone sierraleonés', 0.00018);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (140, 'Dólar de las Bermudas', 0.76743);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (141, 'Franco burundí', 0.00050);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (142, 'Ouguiya mauritano', 0.00293);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (143, 'Som kirgistaní', 0.01590);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (144, 'Ngultrum butanés', 0.01411);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (145, 'Som uzbeko', 0.00037);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (146, 'Dólar de las Islas Salomón', 0.10537);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (147, 'Balboa panameña', 0.76743);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (148, 'Dólar surinamés', 0.23613);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (149, 'Derechos especiales de giro del FMI', 1.15594);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (150, 'Lilangeni swazi', 0.08426);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (151, 'Nakfa eritreo', 0.05949);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (152, 'Chelín somalí', 0.00050);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (153, 'Somoni tayiko', 0.16121);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (154, 'Dólar de Liberia', 0.01044);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (155, 'Manat turkmeno', 0.26927);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (156, 'Libra gibraltareña', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (157, 'Loti basotho', 0.08426);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (158, 'Onza de platino', 1133.48298);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (159, 'Franco de las Comoras', 0.00203);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (160, 'Libra esterlina de las Islas Falkland (Malvinas)', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (161, 'Libra de Guernsey', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (162, 'Libra de Jersey', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (163, 'Libra manesa', 1.18798);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (164, 'Colón salvadoreño', 0.08771);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (165, 'Dobra santotomense', 0.00004);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (166, 'Luigino de Seborga', 4.60458);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (167, 'Onza de paladio', 519.94936);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (168, 'Dólar de Tuvalu', 0.78896);
INSERT INTO LKP_MONEDA (ID_MONEDA, DESC_MONEDA, VALOR_EURO) VALUES (169, 'Libra de Santa Elena', 1.18798);

COMMIT;

INSERT INTO "DATABASKET"."LKP_AMBITO" (ID_AMBITO, DESC_AMBITO) VALUES ('1', 'NACIONAL');
INSERT INTO "DATABASKET"."LKP_AMBITO" (ID_AMBITO, DESC_AMBITO) VALUES ('2', 'CONTINENTAL');

INSERT INTO "DATABASKET"."LKP_CATEGORIA" (ID_CATEGORIA, DESC_CATEGORIA) VALUES ('1', 'PRIMERA');
INSERT INTO "DATABASKET"."LKP_CATEGORIA" (ID_CATEGORIA, DESC_CATEGORIA) VALUES ('2', 'SEGUNDA');


INSERT INTO "DATABASKET"."LKP_MODALIDAD" (ID_MODALIDAD, DESC_MODALIDAD) VALUES ('1', 'NORMAL');
INSERT INTO "DATABASKET"."LKP_MODALIDAD" (ID_MODALIDAD, DESC_MODALIDAD) VALUES ('2', 'SILLA RUEDAS');

INSERT INTO "DATABASKET"."LKP_ROL_ARBITRO" (ID_ROL, DESC_ROL) VALUES ('1', 'PRINCIPAL');
INSERT INTO "DATABASKET"."LKP_ROL_ARBITRO" (ID_ROL, DESC_ROL) VALUES ('2', 'PRIMER AUXILIAR');
INSERT INTO "DATABASKET"."LKP_ROL_ARBITRO" (ID_ROL, DESC_ROL) VALUES ('3', 'SEGUNDO AUXILIAR');
INSERT INTO "DATABASKET"."LKP_ROL_ARBITRO" (ID_ROL, DESC_ROL) VALUES ('4', 'TERCER AUXILIAR');

COMMIT;

INSERT INTO "DATABASKET"."LKP_ROL_TECNICO" (ID_ROL, DESC_ROL) VALUES ('1', 'PRIMER ENTRENADOR');
INSERT INTO "DATABASKET"."LKP_ROL_TECNICO" (ID_ROL, DESC_ROL) VALUES ('2', 'SEGUNDO ENTRENADOR');
COMMIT;


INSERT INTO "DATABASKET"."LKP_SUBESTADO" (ID_SUBESTADO, DESC_SUBESTADO) VALUES ('1', 'BAJA MEDICA');
INSERT INTO "DATABASKET"."LKP_SUBESTADO" (ID_SUBESTADO, DESC_SUBESTADO) VALUES ('2', 'BAJA MOTIVOS PERSONALES');
commit;

INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1001','ERROR – Altura no válida');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1002','ERROR – árbitro no disponible');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1003','ERROR – Compensación no válida');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1004','ERROR – El ámbito no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1005','ERROR – El año es inválido');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1006','ERROR – El árbitro  no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1007','ERROR – El contrato no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1008','ERROR – El equipo comprador no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1009','ERROR – El equipo local no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1010','ERROR – El equipo vendedor no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1011','ERROR – El equipo visitante no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1012','ERROR – El estado no existe ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1013','ERROR – El género no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1014','ERROR – El jugador no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1015','ERROR – El jugador ya está convocado');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1016','ERROR – El país no existe ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1017','ERROR – El partido no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1018','ERROR – El representante no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1019','ERROR – El rol no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1020','ERROR – Fecha de fin incorrecta');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1021','ERROR – Fecha de inicio incorrecta');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1022','ERROR – Fecha de nacimiento incorrecta ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1023','ERROR – Fecha fuera de temporada');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1024','ERROR – Formato de fecha de fin incorrecta');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1025','ERROR – Formato de fecha de inicio incorrecta');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1026','ERROR – Formato de fecha de nacimiento incorrecta ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1027','ERROR – No se ha indicado la compensación');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1028','ERROR – Salario no válido');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1029','ERROR – Jugador de baja');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1030','ERROR – Jugador incorrecto');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1031','ERROR – Jugador retirado');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1032','ERROR – La actividad no existe ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1033','ERROR – La competición no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1034','ERROR – La fecha de fin ha de ser mayor a la fecha de inicio');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1035','ERROR – La modalidad no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1036','ERROR – La moneda no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1037','ERROR – La posición no existe ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1038','ERROR – La temporada no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1039','ERROR – No se ha indicado el ámbito');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1040','ERROR – No se ha indicado el año');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1041','ERROR – No se ha indicado el apellido ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1042','ERROR – No se ha indicado el árbitro ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1043','ERROR – No se ha indicado el contrato');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1044','ERROR – No se ha indicado el equipo comprador');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1045','ERROR – No se ha indicado el equipo local');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1046','ERROR – No se ha indicado el equipo vendedor. No es el primer contrato');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1047','ERROR – No se ha indicado el equipo visitante');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1048','ERROR – No se ha indicado el estado ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1049','ERROR – No se ha indicado el género');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1050','ERROR – No se ha indicado el jugador');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1051','ERROR – No se ha indicado el nombre ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1052','ERROR – No se ha indicado el numero de federado ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1053','ERROR – No se ha indicado el partido');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1054','ERROR – No se ha indicado el peso ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1055','ERROR – No se ha indicado el representante');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1056','ERROR – No se ha indicado el rol');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1057','ERROR – No se ha indicado la actividad ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1058','ERROR – No se ha indicado la altura ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1059','ERROR – No se ha indicado la competición');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1060','ERROR – No se ha indicado la fecha de nacimiento ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1061','ERROR – No se ha indicado la federación ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1062','ERROR – No se ha indicado la modalidad');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1063','ERROR – No se ha indicado la moneda');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1064','ERROR – No se ha indicado la nacionalidad ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1065','ERROR – No se ha indicado la posición ');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1066','ERROR – No se ha indicado la temporada');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1067','ERROR – No se han encontrado datos');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1068','ERROR – Numero federado duplicado');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1069','ERROR – Peso no válido');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1070','ERROR – La federación no existe');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1071','ERROR – No se ha indicado el país');
insert into LKP_ERRORES (ID_ERROR, DESC_ERROR) values ('-1072','ERROR – No se ha indicado el salario');
INSERT INTO LKP_ERRORES (ID_ERROR, DESC_ERROR) VALUES ('-1073','ERROR – Numero federado existente ');

COMMIT;

/

-- -----------------------------------------------------
-- Procesos
-- -----------------------------------------------------
/*
	NOMBRE: WRITE_LOG
	DESCRIPCION: Se encarga de insertar un entrada de log en la tabla de log
*/
create or replace 
procedure              write_log ( in_proc in varchar2, in_text in varchar2, in_err in number, in_errtext in varchar2, in_sql in varchar2, in_log_level in varchar2 default null) is
   ecode NUMBER;
   emesg VARCHAR2(200);
begin
	
   insert into DATABASKET.log_table
   values (seq_log_table.nextval, sysdate, in_proc, SUBSTR(in_text, 1, 250), in_err, SUBSTR(in_errtext, 1, 50), SUBSTR(in_sql, 1, 4000), nvl(in_log_level, 'TRACE'));
   commit;

exception
when others then
   ecode := SQLCODE;
   emesg := SUBSTR(SQLERRM,1,199);
   insert into DATABASKET.log_table
   values (seq_log_table.nextval, sysdate, 'Write_Log', 'Error al escribir el mensaje de ' || in_proc, to_char(ecode), emesg, null, 'ERROR');
   commit;
END;

/

-- -----------------------------------------------------
-- TRIGGERS
-- -----------------------------------------------------

/*
	NOMBRE: TRG_EST_CONTRATO
	DESCRIPCION: Se encarga de calcular el importe total de un contrato antes de insertarlo o modificarlo
*/

create or replace 
TRIGGER TRG_EST_CONTRATO BEFORE INSERT OR UPDATE 
on DATABASKET.CONTRATO
for each row

DECLARE

  PRAGMA AUTONOMOUS_TRANSACTION;
  ecode number;
  emesg varchar2(200);
  
  v_existe  number;
  
  v_PROC  VARCHAR2(30) := 'TRG_EST_CONTRATO';
  
  V_IMPORTE   number;
  
  V_ID_JUGADOR  NUMBER;
BEGIN
  -- Indicamos que se inicia el proceso  
  write_log ( v_PROC, 'Iniciando proceso para '||:NEW.ID_CONTRATO, NULL, NULL, null, NULL);  

	-- Calculamos el valor del importe 
   V_IMPORTE := :NEW.SALARIO + :NEW.COMPENSACION;

   -- Actualizamos el valor del campo importe
   select V_IMPORTE
   into :new.IMPORTE 
   FROM DUAL;
     

EXCEPTION
  WHEN OTHERS THEN
	--Si se ha producido un error lo indicamos en el log
  ecode := SQLCODE;
  emesg := SQLERRM;  
  write_log ( v_PROC, NULL, ecode, emesg, NULL, 'ERROR');    
END TRG_EST_CONTRATO;
/

/*
	NOMBRE: TRG_ESTADISTICA_PARTIDO
	DESCRIPCION: Se encarga de calcular la valoración total a la hora de insertar o modificar una estadistica
*/
create or replace 
TRIGGER TRG_ESTADISTICA_PARTIDO BEFORE update or INSERT ON databasket.estadistica 
FOR EACH ROW
DECLARE
  PRAGMA AUTONOMOUS_TRANSACTION;
  V_PONDERACION   NUMBER;
  V_VALORACION    NUMBER;
  V_CONT		  NUMBER;
  ecode number;
  emesg varchar2(200);
  
  v_PROC  VARCHAR2(30) := 'TRG_ESTADISTICA_PARTIDO';
  
BEGIN
  -- Indicamos que se inicia el proceso
  write_log ( v_PROC, 'Iniciando proceso para '||:NEW.ID_ESTADISTICA, NULL, NULL, NULL, 'TRACE');

  -- Calculamos la valoracion
  V_VALORACION := :NEW.PUNTOS + :NEW.T_LIBRE_OK + :NEW.T_DOS_OK  + :NEW.T_TRES_OK + :NEW.REBOTES_DEFENSIVOS 
                + :NEW.REBOTES_OFENSIVOS + :NEW.ASISTENCIAS + :NEW.TAP_REALIZADOS + :NEW.RECUPERACIONES 
                + :NEW.FAL_RECIBIDAS - :NEW.T_LIBRE - :NEW.T_DOS - :NEW.T_TRES - :NEW.TAP_RECIBIDOS 
                - :NEW.PERDIDAS - :NEW.FAL_REALIZADAS;

   --Actuliazamos el valor del campo valoracion    
   SELECT V_VALORACION
   INTO :NEW.valoracion
   FROM DUAL;

	-- Comprobamos si esta asociada a un partido (solo sirve para actualizaciones)
	if (updating) then

		select count(*) 
		INTO V_CONT
		from rel_est_jug_par 
		where id_estadistica = :OLD.ID_ESTADISTICA;

		-- Si esta asociada, calculamos la valoracion ponderada
		IF V_CONT > 0 THEN
			-- Calculamos la valoracion ponderada
			SELECT TEMP.PONDERACION * V_VALORACION
			  INTO V_PONDERACION
			  FROM PARTIDO PART, TEMPORADA TEMP,  rel_est_jug_par REL
			  WHERE REL.ID_ESTADISTICA = :OLD.ID_ESTADISTICA
			  AND  PART.ID_PARTIDO = REL.ID_PARTIDO
			  AND  PART.ID_TEMPORADA = TEMP.ID_TEMPORADA;
			-- Actualizamos el valor de valoracion ponderada
			SELECT V_PONDERACION
			   INTO :NEW.valoracion_PONDERADA
			   FROM DUAL;

		END IF;
   END IF;
EXCEPTION
  WHEN OTHERS THEN
	--Si se ha producido un error lo indicamos en el log
  ecode := SQLCODE;
  emesg := SQLERRM;
  write_log ( v_PROC, NULL, ecode, emesg, null, 'ERROR');

END TRG_ESTADISTICA_PARTIDO;

/

/*
	NOMBRE: TRG_ESTADISTICA_PONDERADA
	DESCRIPCION: Se encarga de calcular la valoración ponderada una vez se asigna una estadistica a un jugador
*/

create or replace 
TRIGGER TRG_ESTADISTICA_PONDERADA AFTER INSERT OR UPDATE ON databasket.rel_est_jug_par 
FOR EACH ROW
DECLARE
  PRAGMA AUTONOMOUS_TRANSACTION;
  V_PONDERACION   NUMBER;
  V_VALORACION    NUMBER;
  
  ecode number;
  emesg VARCHAR2(200);
  
  v_PROC  VARCHAR2(30) := 'TRG_ESTADISTICA_PONDERADA';
  
BEGIN
  -- Indicamos que se inicia el proceso
  write_log ( v_PROC, 'Iniciando proceso para '||:NEW.ID_ESTADISTICA, NULL, NULL, null, 'TRACE');
	
	-- Calculo de la estadistica ponderada
  SELECT TEMP.PONDERACION * EST.VALORACION
  INTO V_PONDERACION
  FROM PARTIDO PART, TEMPORADA TEMP, ESTADISTICA EST 
  WHERE EST.ID_ESTADISTICA = :new.ID_ESTADISTICA
  AND  PART.ID_PARTIDO = :NEW.ID_PARTIDO
  AND  PART.ID_TEMPORADA = TEMP.ID_TEMPORADA;
  
-- Actualizamos la estadistica ponderada
  UPDATE databasket.estadistica 
      SET VALORACION_PONDERADA = V_PONDERACION
      where ID_ESTADISTICA =:new.ID_ESTADISTICA;

EXCEPTION
  WHEN OTHERS THEN
	--Si se ha producido un error lo indicamos en el log
    ecode := SQLCODE;
    emesg := SQLERRM;
    write_log ( v_PROC, NULL, ecode, emesg, NULL, 'ERROR');  
END TRG_ESTADISTICA_PONDERADA;
/
-- -----------------------------------------------------
-- Paquetes
-- -----------------------------------------------------
/*
	NOMBRE: PKG_VALIDACIONES
	DESCRIPCION: Paquete que contiene todas las validaciones necesarias para los procesos de ABM
		Cada validación individual retorna:
			 nulo: si la validación es correcta
			 numero de error: Si la validación es incorrecta. Este numero corresponde con la tabla de LKP_ERRORES
*/
create or replace 
PACKAGE PKG_VALIDACIONES AS 

  V_COUNT     NUMBER;
  
  -- Rango de fechas finales validas
  C_FECHA_FIN_INI  date:= TO_DATE('01/01/1950');
  C_FECHA_FIN_FIN  date:= to_date('01/01/2030');
  
  -- Rango de fechas iniciales validas
  C_FECHA_INICIO_INI  date:= TO_DATE('01/01/1950');
  C_FECHA_INICIO_FIN  date:= to_date('01/01/2020');
  
  -- Edad minima para tener un contrato
  C_EDAD_MINIMA       number:=016;

  -- METODOS GENERICOS 
  FUNCTION F_CHECK_NUMBER(IN_NUM VARCHAR2) RETURN NUMBER;
  FUNCTION F_CHECK_DATE(IN_DATE VARCHAR2) RETURN NUMBER;
  
  
  -- METODOS ESPECIFICOS
  FUNCTION F_VALIDA_FEDERACION(IN_FEDERACION VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_PAIS(IN_PAIS VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_ALTURA(IN_ALTURA VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_ARBITRO(IN_ARBITRO VARCHAR2, IN_PARTIDO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_COMPENSACION(IN_COMPENSACION VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_SALARIO(IN_SALARIO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_AMBITO(IN_AMBITO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_ANYO(IN_ANYO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_CONTRATO(IN_CONTRATO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_EQUIPO_COMPRADOR(IN_EQUIPO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_EQUIPO_LOCAL(IN_EQUIPO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_EQUIPO_VENDEDOR(IN_EQUIPO VARCHAR2, IN_FECHA_INI VARCHAR2, IN_JUGADOR VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_EQUIPO_VISITANTE(IN_EQUIPO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_ESTADO(IN_ESTADO VARCHAR2) RETURN NUMBER;
  function F_VALIDA_GENERO(IN_GENERO varchar2) return number;
  function F_VALIDA_JUGADOR(IN_JUGADOR varchar2) return number;
  FUNCTION F_VALIDA_JUGADOR_CONVOCADO(IN_JUGADOR VARCHAR2, IN_PARTIDO VARCHAR2) RETURN NUMBER; 
  FUNCTION F_VALIDA_PARTIDO(IN_PARTIDO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_REPRESENTANTE(IN_REPRESENTANTE VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_ROL_ARBITRO(IN_ROL VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_FECHA_FIN(IN_FECHA VARCHAR2) RETURN NUMBER;
  function F_VALIDA_FECHA_INICIO(IN_FECHA varchar2) return number;
  FUNCTION F_VALIDA_FECHA_NACIMIENTO(IN_FECHA VARCHAR2) RETURN NUMBER;
  function F_VALIDA_FECHA_TEMPORADA(IN_FECHA varchar2, IN_TEMPORADA varchar2) return number;
  function F_VALIDA_ACTIVIDAD(IN_ACTIVIDAD varchar2) return number;
  FUNCTION F_VALIDA_COMPETICION(IN_COMPETICION VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_FECHAS(IN_FECHA_INICIO VARCHAR2, FECHA_FIN VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_MODALIDAD(IN_MODALIDAD VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_MONEDA(IN_MONEDA VARCHAR2) RETURN NUMBER;
  function F_VALIDA_POSICION(IN_POSICION varchar2) return number;
  FUNCTION F_VALIDA_TEMPORADA(IN_TEMPORADA VARCHAR2) RETURN NUMBER;
  function F_VALIDA_NOMBRE(IN_NOMBRE varchar2) return number;
  FUNCTION F_VALIDA_APELLIDO(IN_APELLIDO VARCHAR2) RETURN NUMBER;
  FUNCTION F_VALIDA_NACIONALIDAD(IN_NACIONALIDAD VARCHAR2) RETURN NUMBER;
  function F_VALIDA_PESO(IN_PESO varchar2) return number;
  function F_VALIDA_NUM_FEDERADO(IN_NUM_FED varchar2, IN_PAIS varchar2) return number;
  function F_VALIDA_NUM_FEDERADO_DUP(IN_JUGADOR VARCHAR2,IN_NUM_FED varchar2, IN_PAIS varchar2) return number;
  FUNCTION F_VALIDA_JUGADOR_RETIRADO(IN_JUGADOR VARCHAR2) RETURN NUMBER;
  
END PKG_VALIDACIONES;
/
create or replace 
PACKAGE BODY PKG_VALIDACIONES AS


  -- Si es un numero valido
   -- 0 No valido
   -- 1 Valido

  function F_CHECK_NUMBER(IN_NUM varchar2) return number as
    V_NUMBER  number;
  BEGIN
    
    V_COUNT := 1;
    -- Comprobación numerica
    select TO_NUMBER(IN_NUM)
      INTO V_NUMBER
      FROM dual;
    
    -- Comprobación si es negativo
    
    IF V_NUMBER < 0  THEN
      V_COUNT := 0;
    END IF;
      
    RETURN V_COUNT;
    
  EXCEPTION when OTHERS then
        RETURN 0;      
  END F_CHECK_NUMBER;
  
  FUNCTION F_CHECK_DATE(IN_DATE VARCHAR2) RETURN NUMBER AS
      V_DATE date;
  begin
  
    if OWA_PATTERN.MATCH(IN_DATE, '^\d{2}/\d{2}/\d{4}$') THEN   
      select TO_DATE(IN_DATE,'DD/MM/YYYY') into V_DATE from DUAL;
        return 1;
    else
      RETURN 0;
    END IF;
  Exception WHEN Others THEN
        RETURN 0;
  END F_CHECK_DATE;
  
  
  -- Validacion de federación
  FUNCTION F_VALIDA_FEDERACION(IN_FEDERACION VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_FEDERACION IS NULL THEN
      RETURN -1061;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM LKP_PAIS
    WHERE ID_PAIS = IN_FEDERACION;
    
    IF V_COUNT = 0 THEN
      RETURN -1070;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_FEDERACION;
  
  -- Validacion de pais
  
  FUNCTION F_VALIDA_PAIS(IN_PAIS VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_PAIS IS NULL THEN
      RETURN -1071;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM LKP_PAIS
    WHERE ID_PAIS = IN_PAIS;
    
    IF V_COUNT = 0 THEN
      RETURN -1016;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_PAIS;
  
  -- Validación de altura
  FUNCTION F_VALIDA_ALTURA(IN_ALTURA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_ALTURA IS NULL THEN
      RETURN -1058;
    END IF;
    
    -- Si es un numero valido
  
    V_COUNT:= F_CHECK_NUMBER(IN_ALTURA);
    
    
    IF V_COUNT = 0 THEN
      RETURN -1001;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_ALTURA;
  
  FUNCTION F_VALIDA_ARBITRO(IN_ARBITRO VARCHAR2, IN_PARTIDO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_ARBITRO IS NULL THEN
      RETURN -1042;
    END IF;
    
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM ARBITRO
    WHERE ID_ARBITRO = IN_ARBITRO;
    
    IF V_COUNT = 0 THEN
      RETURN -1006;
    END IF;
    
    -- Si ya está asignado al partido
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM rel_arb_partido
    WHERE ID_ARBITRO = IN_ARBITRO
    AND  id_partido = IN_PARTIDO;
    
    IF V_COUNT > 0 THEN
      RETURN -1002;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_ARBITRO;
  
    -- Validación de compensacion
  FUNCTION F_VALIDA_COMPENSACION(IN_COMPENSACION VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_COMPENSACION IS NULL THEN
      RETURN -1027;
    END IF;
    
    -- Si es un numero valido
    V_COUNT:= F_CHECK_NUMBER(IN_COMPENSACION);
        
    if V_COUNT = 0 then
      RETURN -1003;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_COMPENSACION;
  
      -- Validación de salario
  FUNCTION F_VALIDA_SALARIO(IN_SALARIO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_SALARIO is null then
      RETURN -1072;
    END IF;
    
    -- Si es un numero valido
    V_COUNT:= F_CHECK_NUMBER(IN_SALARIO);
        
    IF V_COUNT = 0 THEN
      RETURN -1028;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_SALARIO;
  
    -- Validacion de ambito
  
  FUNCTION F_VALIDA_AMBITO(IN_AMBITO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_AMBITO IS NULL THEN
      RETURN -1039;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM LKP_AMBITO
    WHERE ID_AMBITO = IN_AMBITO;
    
    IF V_COUNT = 0 THEN
      RETURN -1004;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_AMBITO;
  
        -- Validación de AÑO
  FUNCTION F_VALIDA_ANYO(IN_ANYO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_ANYO IS NULL THEN
      RETURN -1040;
    END IF;
    
    -- Si es un año valido
    V_COUNT:= F_CHECK_DATE('01/01/'||IN_ANYO);
        
    IF V_COUNT = 0 THEN
      RETURN -1005;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_ANYO;
  
      -- Validacion de CONTRATO
  
  FUNCTION F_VALIDA_CONTRATO(IN_CONTRATO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_CONTRATO IS NULL THEN
      RETURN -1043;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM CONTRATO
    WHERE ID_CONTRATO = IN_CONTRATO;
    
    IF V_COUNT = 0 THEN
      RETURN -1007;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_CONTRATO;
  
        -- Validacion de EQUIPO COMPRADOR
  
  FUNCTION F_VALIDA_EQUIPO_COMPRADOR(IN_EQUIPO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_EQUIPO IS NULL THEN
      RETURN -1044;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM EQUIPO
    WHERE ID_EQUIPO = IN_EQUIPO;
    
    IF V_COUNT = 0 THEN
      RETURN -1008;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_EQUIPO_COMPRADOR;
  
          -- Validacion de EQUIPO LOCAL
  
  FUNCTION F_VALIDA_EQUIPO_LOCAL(IN_EQUIPO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_EQUIPO IS NULL THEN
      RETURN -1045;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM EQUIPO
    WHERE ID_EQUIPO = IN_EQUIPO;
    
    IF V_COUNT = 0 THEN
      RETURN -1009;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_EQUIPO_LOCAL;
  
  -- Validacion de EQUIPO VENDEDOR
  
  FUNCTION F_VALIDA_EQUIPO_VENDEDOR(IN_EQUIPO VARCHAR2, IN_FECHA_INI VARCHAR2, IN_JUGADOR VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo y el jugador tiene un contrato anterior
    IF IN_EQUIPO IS NULL THEN
      SELECT COUNT(*)
      into v_count
      FROM CONTRATO
      WHERE ID_JUGADOR = IN_JUGADOR
      AND FECHA_INICIO < IN_FECHA_INI;
      
      IF V_COUNT > 0 THEN
        RETURN -1046;
      end if;
   else
      -- Si existe EL EQUIPO
      SELECT COUNT(*) 
      INTO V_COUNT
      FROM EQUIPO
      WHERE ID_EQUIPO = IN_EQUIPO;
      
      IF V_COUNT = 0 THEN
        RETURN -1010;
      end if;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_EQUIPO_VENDEDOR;
  
            -- Validacion de EQUIPO VISITANTE
  
  FUNCTION F_VALIDA_EQUIPO_VISITANTE(IN_EQUIPO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_EQUIPO IS NULL THEN
      RETURN -1047;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM EQUIPO
    WHERE ID_EQUIPO = IN_EQUIPO;
    
    IF V_COUNT = 0 THEN
      RETURN -1011;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_EQUIPO_VISITANTE;

            -- Validacion de ESTADO
  
  FUNCTION F_VALIDA_ESTADO(IN_ESTADO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_ESTADO IS NULL THEN
      RETURN -1048;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM LKP_ESTADO
    WHERE ID_ESTADO = IN_ESTADO;
    
    IF V_COUNT = 0 THEN
      RETURN -1012;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_ESTADO;  

            -- Validacion de GENERO
  
  FUNCTION F_VALIDA_GENERO(IN_GENERO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_GENERO IS NULL THEN
      RETURN -1049;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    FROM LKP_GENERO
    WHERE ID_GENERO = IN_GENERO;
    
    IF V_COUNT = 0 THEN
      RETURN -1013;
    END IF;
    
    RETURN NULL;
  END F_VALIDA_GENERO;  
  
  
   -- Validacion de Jugador
  FUNCTION F_VALIDA_JUGADOR(IN_JUGADOR VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_JUGADOR is null then
      RETURN -1050;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    from JUGADOR
    where ID_JUGADOR = IN_JUGADOR;
    
    IF V_COUNT = 0 THEN
      RETURN -1014;
    END IF;
    
    return null;
  end F_VALIDA_JUGADOR;  
  
   -- Validacion de Jugador Convocado
   -- El partido ha de existir previamente
  FUNCTION F_VALIDA_JUGADOR_CONVOCADO(IN_JUGADOR VARCHAR2, IN_PARTIDO VARCHAR2) RETURN NUMBER AS
  
    V_FECHA_PARTIDO   PARTIDO.FECHA_INICIO%type;
    v_temporada       partido.ID_TEMPORADA%type;  
  BEGIN
    
    -- Nulo
    if IN_JUGADOR is null then
      RETURN -1050;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    from JUGADOR
    where ID_JUGADOR = IN_JUGADOR;
    
    IF V_COUNT = 0 THEN
      RETURN -1014;
    end if;
    
    -- Si ya esta convocado
    SELECT COUNT(*) 
    into V_COUNT
    from REL_JUGADOR_PARTIDO
    where ID_JUGADOR = IN_JUGADOR
    and id_partido = IN_PARTIDO;
    
    if V_COUNT > 0 then
      RETURN -1015;
    end if;
    
    select FECHA_INICIO, ID_TEMPORADA
    INTO v_fecha_partido, v_temporada
    from PARTIDO
    where ID_PARTIDO = IN_PARTIDO;
    
    -- Comprobamos que el jugador pertenece a alguno de los clubes que disputan el partido
    SELECT COUNT(*) 
    into V_COUNT
    from CONTRATO CON, PARTIDO PAR
    where ID_JUGADOR = IN_JUGADOR
    and  PAR.ID_PARTIDO = IN_PARTIDO
    and ID_EQUIPO_COMPRADOR in (PAR.ID_EQUIPO_LOCAL, PAR.ID_EQUIPO_VISITANTE)
    and par.FECHA_INICIO BETWEEN con.FECHA_INICIO AND con.FECHA_FIN;
    
    if V_COUNT = 0 then
      RETURN -1030;
    end if;
    
    
    -- Comprobamos que no este de baja para la fecha del partido
    SELECT COUNT(*) 
    into V_COUNT
    from HIST_MEDICO
    where ID_JUGADOR = IN_JUGADOR
    and  v_fecha_partido BETWEEN fecha_inicio and nvl(fecha_final, sysdate);
    
    if V_COUNT > 0 then
      return -1029;
    end if;
    
    
    -- Comprobamos que no este retirado  
    SELECT COUNT(*) 
    into V_COUNT
    from JUGADOR
    where ID_JUGADOR = IN_JUGADOR
    and  id_actividad = 1;
    
    if V_COUNT = 0 then
      return -1031;
    end if;
        
    return null;
  END F_VALIDA_JUGADOR_CONVOCADO;  
  
     -- Validacion de Partido
  FUNCTION F_VALIDA_PARTIDO(IN_PARTIDO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_PARTIDO is null then
      RETURN -1053;
    END IF;
    
    -- Si existe
    select COUNT(*)
    INTO V_COUNT
    from PARTIDO
    where ID_PARTIDO = IN_PARTIDO;
    
    if V_COUNT = 0 then
      RETURN -1017;
    END IF;
    
    return null;
  end F_VALIDA_PARTIDO;  
  
     -- Validacion de Partido
  FUNCTION F_VALIDA_REPRESENTANTE(IN_REPRESENTANTE VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_REPRESENTANTE is null then
      RETURN -1055;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from REPRESENTANTE
    where ID_REPRESENTANTE = IN_REPRESENTANTE;
    
    if V_COUNT = 0 then
      RETURN -1018;
    END IF;
    
    return null;
  end F_VALIDA_REPRESENTANTE;  

  
      -- Validacion de rol de arbitro en partidos
  FUNCTION F_VALIDA_ROL_ARBITRO(IN_ROL VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_ROL is null then
      RETURN -1056;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from LKP_ROL_ARBITRO
    where ID_ROL = IN_ROL;
    
    if V_COUNT = 0 then
      RETURN -1019;
    END IF;
    
    return null;
  end F_VALIDA_ROL_ARBITRO;  
  
        -- Validacion de FECHA FIN
  FUNCTION F_VALIDA_FECHA_FIN(IN_FECHA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if (IN_FECHA is null or F_CHECK_DATE(IN_FECHA) = 0) then
      RETURN -1024;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from DUAL
    where TO_DATE(in_FECHA,'DD/MM/YYYY') between C_FECHA_FIN_INI  AND  C_FECHA_FIN_FIN;
    
    if V_COUNT = 0 then
      RETURN -1020;
    END IF;
    
    return null;
  end F_VALIDA_FECHA_FIN;  
  
          -- Validacion de FECHA INICIO
  FUNCTION F_VALIDA_FECHA_INICIO(IN_FECHA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if (IN_FECHA is null or F_CHECK_DATE(IN_FECHA) = 0) then
      RETURN -1025;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from DUAL
    where TO_DATE(in_FECHA,'DD/MM/YYYY') between C_FECHA_INICIO_INI  AND  C_FECHA_INICIO_FIN;
    
    if V_COUNT = 0 then
      RETURN -1021;
    END IF;
    
    return null;
  end F_VALIDA_FECHA_INICIO;  
  
  -- Validacion de FECHA NACIMIENTO
  FUNCTION F_VALIDA_FECHA_NACIMIENTO(IN_FECHA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_FECHA is null then
      return -1060;
    END IF;
    
    -- Formato
    if F_CHECK_DATE(IN_FECHA) = 0 then
      RETURN -1026;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from DUAL
    where TO_DATE(in_FECHA,'DD/MM/YYYY') between C_FECHA_INICIO_INI  AND  ADD_MONTHS(SYSDATE, (-12*C_EDAD_MINIMA));
    
    if V_COUNT = 0 then
      RETURN -1022;
    END IF;
    
    return null;
  end F_VALIDA_FECHA_NACIMIENTO;  
  
    -- Validacion de fecha dentro o fuera de temporada
  function F_VALIDA_FECHA_TEMPORADA(IN_FECHA varchar2, IN_TEMPORADA varchar2) return number as
  
    V_FECHA_INICIO    TEMPORADA.FECHA_INICIO%type;
    V_FECHA_FIN       TEMPORADA.FECHA_FIN%TYPE;
  
  begin
  
    select FECHA_INICIO, FECHA_FIN
    into V_FECHA_INICIO, V_FECHA_FIN
    FROM TEMPORADA
    WHERE ID_tEMPORADA = In_temporada;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from DUAL
    where TO_DATE(in_FECHA,'DD/MM/YYYY') between V_FECHA_INICIO  AND  V_FECHA_FIN;
    
    if V_COUNT = 0 then
      RETURN -1023;
    END IF;
    
    return null;
  end F_VALIDA_FECHA_TEMPORADA;  
  
      -- Validacion de actividad
  FUNCTION F_VALIDA_ACTIVIDAD(IN_ACTIVIDAD VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_ACTIVIDAD is null then
      RETURN -1057;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from LKP_ACTIVIDAD
    where Id_ACTIVIDAD = IN_ACTIVIDAD;
    
    if V_COUNT = 0 then
      RETURN -1032;
    END IF;
    
    return null;
  end F_VALIDA_ACTIVIDAD;    
  
        -- Validacion de COMPETICION
  FUNCTION F_VALIDA_COMPETICION(IN_COMPETICION VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_COMPETICION is null then
      RETURN -1059;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from COMPETICION
    where Id_COMPETICION = IN_COMPETICION;
    
    if V_COUNT = 0 then
      RETURN -1033;
    END IF;
    
    return null;
  end F_VALIDA_COMPETICION;    
  
          -- Validacion de FECHA DE INICIO < FECHA FIN
  FUNCTION F_VALIDA_FECHAS(IN_FECHA_INICIO VARCHAR2, FECHA_FIN VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    V_COUNT := 0;
    -- Si existe
    BEGIN
      select 1
      into V_COUNT
      from DUAL
      where TO_DATE(IN_FECHA_INICIO,'DD/MM/YYYY') > TO_DATE(FECHA_FIN,'DD/MM/YYYY');
    EXCEPTION
      when NO_DATA_FOUND then
      V_COUNT :=0;
    end;
    
    if V_COUNT = 1 then
      RETURN -1034;
    END IF;
    
    return null;
  end F_VALIDA_FECHAS; 
  
          -- Validacion de MODALIDAD
  FUNCTION F_VALIDA_MODALIDAD(IN_MODALIDAD VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_MODALIDAD is null then
      RETURN -1062;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from LKP_MODALIDAD
    where ID_MODALIDAD = IN_MODALIDAD;
    
    if V_COUNT = 0 then
      RETURN -1035;
    END IF;
    
    return null;
  end F_VALIDA_MODALIDAD; 
  
            -- Validacion de MONEDA
  FUNCTION F_VALIDA_MONEDA(IN_MONEDA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_MONEDA is null then
      return -1063;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from LKP_MONEDA
    where ID_MONEDA = IN_MONEDA;
    
    if V_COUNT = 0 then
      RETURN -1036;
    END IF;
    
    return null;
  end F_VALIDA_MONEDA; 

            -- Validacion de POSICION
  FUNCTION F_VALIDA_POSICION(IN_POSICION VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_POSICION is null then
      return -1065;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from LKP_POSICION
    where ID_POSICION = IN_POSICION;
    
    if V_COUNT = 0 then
      RETURN -1037;
    END IF;
    
    return null;
  end F_VALIDA_POSICION;   
  
              -- Validacion de TEMPORADA
  FUNCTION F_VALIDA_TEMPORADA(IN_TEMPORADA VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_TEMPORADA is null then
      return -1066;
    END IF;
    
    -- Si existe
    select COUNT(*)
    into V_COUNT
    from TEMPORADA
    where ID_TEMPORADA = IN_TEMPORADA;
    
    if V_COUNT = 0 then
      RETURN -1038;
    END IF;
    
    return null;
  end F_VALIDA_TEMPORADA;   
  
  FUNCTION F_VALIDA_NOMBRE(IN_NOMBRE VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nombre Nulo
    if IN_NOMBRE is null then
      return -1051;
    end if;
    
    return null;
  end F_VALIDA_NOMBRE;
  
   
  FUNCTION F_VALIDA_APELLIDO(IN_APELLIDO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Apellido Nulo
    if IN_APELLIDO is null then
      return -1041;
    END IF;
    
    return null;
  end F_VALIDA_APELLIDO;
  
 FUNCTION F_VALIDA_NACIONALIDAD(IN_NACIONALIDAD VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    if IN_NACIONALIDAD is null then
      return -1064;
    end if;
    
    return null;
  end F_VALIDA_NACIONALIDAD;  
  
  -- Validación de altura
  FUNCTION F_VALIDA_PESO(IN_PESO VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_PESO IS NULL THEN
      RETURN -1054;
    END IF;
    
    -- Si es un numero valido
  
    V_COUNT:= F_CHECK_NUMBER(IN_PESO);
    
    
    if V_COUNT = 0 then
      RETURN -1069;
    END IF;
    
    return null;
  END F_VALIDA_PESO;
  
    -- Validación de numero de federado
  FUNCTION F_VALIDA_NUM_FEDERADO(IN_NUM_FED VARCHAR2, IN_PAIS VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_NUM_FED IS NULL THEN
      RETURN -1052;
    END IF;
    
    -- Si existe el numero de federado para ese pais
  
    select COUNT(*)
    into v_count
    from JUGADOR
    where NUMERO_FEDERADO = IN_NUM_FED
    and FEDERACION = IN_PAIS;
    
    
    if V_COUNT > 0 then
      RETURN -1073;
    END IF;
    
    return null;
  END F_VALIDA_NUM_FEDERADO;
  
   -- Validación de numero de federado duplicado
  FUNCTION F_VALIDA_NUM_FEDERADO_DUP (IN_JUGADOR VARCHAR2, IN_NUM_FED VARCHAR2, IN_PAIS VARCHAR2) RETURN NUMBER AS
  BEGIN
    
    -- Nulo
    IF IN_NUM_FED IS NULL THEN
      RETURN -1052;
    END IF;
    
    -- Si esta duplicado en el pais
  
    select COUNT(*)
    into v_count
    from JUGADOR
    where NUMERO_FEDERADO = IN_NUM_FED
    and FEDERACION = IN_PAIS
    AND ID_JUGADOR <> IN_JUGADOR;
    
    
    if V_COUNT > 0 then
      RETURN -1068;
    END IF;
    
    return null;
  end F_VALIDA_NUM_FEDERADO_DUP;

    -- validacion jugador retirado
  FUNCTION F_VALIDA_JUGADOR_RETIRADO(IN_JUGADOR VARCHAR2) RETURN NUMBER AS
   
  BEGIN
    
    -- Nulo
    if IN_JUGADOR is null then
      RETURN -1050;
    END IF;
    
    -- Si existe
    SELECT COUNT(*) 
    INTO V_COUNT
    from JUGADOR
    where ID_JUGADOR = IN_JUGADOR;
    
    IF V_COUNT = 0 THEN
      RETURN -1014;
    end if;
    
    -- Comprobamos que no este retirado  
    SELECT COUNT(*) 
    into V_COUNT
    from JUGADOR
    where ID_JUGADOR = IN_JUGADOR
    and  id_actividad = 1;
    
    if V_COUNT = 0 then
      return -1031;
    end if;
        
    return null;
  END F_VALIDA_JUGADOR_RETIRADO;  

END PKG_VALIDACIONES;

/


create or replace 
PACKAGE PKG_TRIGGERS AS 
  ecode NUMBER;
  emesg VARCHAR2(2000);

  PROCEDURE P_EST_JUGADORES_ACTIVOS;
  
  procedure P_EST_MAXIMO_ANOTADOR;
  
  PROCEDURE P_EST_MEJOR_PAGADO ;
  
  procedure P_EST_MAYOR_GANANCIA ;
  
  PROCEDURE P_EST_SUELDO_MEDIO ;
  
  PROCEDURE P_EST_MEJOR_JUGADOR_MUNDIAL;
  
  PROCEDURE P_EST_MEJORES_EQUIPOS;

END PKG_TRIGGERS;
/
create or replace 
PACKAGE BODY PKG_TRIGGERS AS

  procedure P_EST_JUGADORES_ACTIVOS  as
  V_PROC    VARCHAR2(32):='P_EST_JUGADORES_ACTIVOS';
  BEGIN
  
   WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
    
  WRITE_LOG ( V_PROC, 'Borrado de la tabla EST_JUGADORES_ACTIVOS', null, null, null, 'TRACE'); 
    DELETE FROM DATABASKET.EST_JUGADORES_ACTIVOS;
  COMMIT;
  
  INSERT INTO EST_JUGADORES_ACTIVOS
    select id_genero, id_modalidad, count(*)
    from (
        SELECT com.id_genero, com.id_modalidad, jug.id_jugador, count(*)
        FROM competicion com, VLK_JUGADORES_TEMPORADA REL, jugador jug
        WHERE REL.id_competicion = com.id_competicion
        and REL.ID_JUGADOR = JUG.ID_JUGADOR
        AND jug.id_Actividad = 1
        GROUP BY com.id_genero, com.id_modalidad, jug.id_jugador)
    GROUP BY id_genero, id_modalidad; 
    
    commit;
    
    WRITE_LOG ( V_PROC, 'Fin del proceso sin errores', null, null, null, 'INFO'); 
    
  EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      write_log ( V_PROC, 'Proceso finalizado con errores', ecode, emesg, null, 'ERROR'); 

  END P_EST_JUGADORES_ACTIVOS;
  
  procedure P_EST_MAXIMO_ANOTADOR as
  
   V_PROC    VARCHAR2(32):='P_EST_MAXIMO_ANOTADOR';
   
   V_ID_JUGADOR NUMBER;
   
   V_ID_competicion NUMBER;
   
   cursor C_COMPETICIONES is 
    select id_competicion from competicion;
  
  BEGIN
  
    WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
  
        
    WRITE_LOG ( V_PROC, 'Borrado de la tabla EST_MAXIMO_ANOTADOR', null, null, null, 'TRACE'); 
    delete from DATABASKET.EST_MAXIMO_ANOTADOR;
    commit;
    
    open C_COMPETICIONES;
    LOOP
      FETCH C_COMPETICIONES into V_ID_COMPETICION;
      exit when c_competiciones%notfound;
 
    INSERT INTO EST_MAXIMO_ANOTADOR
        (SELECT id_jugador, id_competicion  
      FROM (
           
          SELECT vjt.id_competicion, vjt.id_jugador, sum(est.puntos) puntos
          FROM vlk_jugadores_temporada vjt, partido par, rel_est_jug_par rel, estadistica est, temporada tem
          WHERE rel.id_jugador = vjt.id_jugador
          AND   rel.id_partido = par.id_partido
          and   PAR.ID_TEMPORADA = VJT.ID_TEMPORADA
          and   tem.id_competicion = v_id_competicion
          AND   est.id_estadistica = rel.id_estadistica
          and   TEM.ID_TEMPORADA = VJT.ID_TEMPORADA
          and   tem.fecha_fin = (SELECT MAX(T2.FECHA_FIN) FECHA
                                          FROM temporada T2
                                         WHERE T2.ID_COMPETICION = tEM.id_competicion  )
          GROUP BY vjt.id_competicion, vjt.id_jugador
          ORDER BY sum(est.puntos) DESC
          )
          where rownum = 1
        )
        ;
  
      commit;
    end LOOP;
    
    close C_COMPETICIONES;
    
       WRITE_LOG ( V_PROC, 'Fin del proceso sin errores', null, null, null, 'INFO'); 
       
EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      write_log ( V_PROC, 'Error', ecode, emesg, null, 'ERROR');  
      
  END P_EST_MAXIMO_ANOTADOR;

 PROCEDURE P_EST_MEJOR_PAGADO AS
 
   CURSOR C_GENEROS IS
      select id_genero, id_modalidad from lkp_genero, lkp_modalidad;

  v_id_modalidad  lkp_modalidad.id_modalidad%TYPE;
  V_ID_GENERO     LKP_GENERO.ID_GENERO%TYPE;
  V_ID_JUGADOR    JUGADOR.ID_JUGADOR%TYPE;
  V_SUELDO        NUMBER;
  
   V_PROC    varchar2(32):='P_EST_MEJOR_PAGADO';
   
  begin
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
  
    DELETE FROM DATABASKET.EST_MEJOR_PAGADO;
  COMMIT;
  
  open c_generos;
  loop
    fetch c_generos into v_id_genero, v_id_modalidad;
    exit when c_generos%notfound;
        
        BEGIN
          select id_jugador, sueldo 
            INTO V_ID_JUGADOR, V_SUELDO
            from (
            select com.id_genero, com.id_modalidad, jug.id_jugador, max((CON.IMPORTE - con.compensacion)  * valor_euro) sueldo
              from competicion com, temporada tem, rel_equipo_temporada rel, contrato con, jugador jug, lkp_moneda mon
              where tem.id_competicion = com.id_competicion
              and rel.id_temporada = tem.id_temporada
              and con.id_equipo_comprador = rel.id_equipo
              AND ( 
                 (con.fecha_fin BETWEEN tem.fecha_inicio AND tem.fecha_fin) 
                OR 
                (con.fecha_inicio BETWEEN tem.fecha_inicio AND tem.fecha_fin ) 
               OR 
               (con.fecha_inicio <= tem.fecha_inicio AND con.fecha_fin >= tem.fecha_fin) )
              and con.id_jugador = jug.id_jugador
              and con.id_moneda = mon.id_moneda
              and COM.ID_GENERO = V_ID_GENERO
              AND COM.ID_MODALIDAD = V_ID_MODALIDAD
              group by com.id_genero, com.id_modalidad, jug.id_jugador
              order by max((CON.IMPORTE - con.compensacion)  * valor_euro)desc
          )
          where rownum = 1; 
          
        EXCEPTION
          WHEN NO_DATA_FOUND THEN
             V_ID_JUGADOR:=NULL;
             V_SUELDO := NULL;
              write_log ( 'P_EST_MEJOR_PAGADO ', 'No se ha encontrado ningun dato para el genero '||V_ID_GENERO||' y Mod '||V_ID_MODALIDAD, NULL, NULL, null, 'TRACE');  
     
        END;
        
      IF V_ID_JUGADOR IS NOT NULL THEN
        INSERT INTO EST_MEJOR_PAGADO
        (ID_JUGADOR, ID_GENERO, ID_MODALIDAD, TOTAL)
        VALUES
        (V_ID_JUGADOR, V_ID_GENERO, V_ID_MODALIDAD, V_SUELDO);
        COMMIT;
      END IF;
      
    END LOOP;
    close c_generos;
       commit;
    WRITE_LOG ( V_PROC, 'Fin del proceso sin errores', null, null, null, 'INFO');        
    
EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      write_log ( 'P_EST_MEJOR_PAGADO ', NULL, ecode, emesg, null, 'ERROR');  
     
  END P_EST_MEJOR_PAGADO;
  
 PROCEDURE P_EST_MAYOR_GANANCIA AS
 
  V_ID_JUGADOR    JUGADOR.ID_JUGADOR%TYPE;
  V_SUELDO        number;
  V_PROC    varchar2(32):='P_EST_MAYOR_GANANCIA';
  
  begin
  
    WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
    DELETE FROM DATABASKET.EST_MAYOR_GANANCIA;
  COMMIT;
  
    select id_jugador, sueldo 
      INTO V_ID_JUGADOR, V_SUELDO
    FROM (
    select ID_JUGADOR, SUM((CON.IMPORTE - con.compensacion)  * valor_euro)  SUELDO
    from contrato CON, LKP_MONEDA MON
    where MON.ID_MONEDA = CON.ID_MONEDA
    GROUP BY ID_JUGADOR
    ORDER BY SUM((CON.IMPORTE - con.compensacion)  * valor_euro)  DESC)
    WHERE ROWNUM = 1;     


      INSERT INTO EST_MAYOR_GANANCIA
      (ID_JUGADOR,  TOTAL)
      VALUES
      (V_ID_JUGADOR, V_SUELDO);
      commit;

  write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'INFO'); 

EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      write_log ( 'P_EST_MAYOR_GANANCIA ', NULL, ecode, emesg, null, 'ERROR');  
       
  END P_EST_MAYOR_GANANCIA;
  
   procedure P_EST_SUELDO_MEDIO  as
   
   V_PROC    varchar2(32):='P_EST_SUELDO_MEDIO';
  begin
  
    WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
    DELETE FROM DATABASKET.EST_SUELDO_MEDIO;
  commit;

    insert into EST_SUELDO_MEDIO
    (
        SELECT com.id_pais, tem.id_temporada,  com.id_genero, com.id_modalidad, round(sum ( (importe- con.compensacion) * valor_euro)/ count(*),2)
      from rel_equipo_temporada rel, temporada tem, competicion com, contrato con, lkp_moneda mon
      where rel.id_temporada = tem.id_temporada
      AND com.id_competicion = tem.id_competicion
      and MON.ID_MONEDA = CON.ID_MONEDA
      and rel.id_equipo = con.id_equipo_comprador
      AND ( 
             (con.fecha_fin BETWEEN tem.fecha_inicio AND tem.fecha_fin) 
            OR 
            (con.fecha_inicio BETWEEN tem.fecha_inicio AND tem.fecha_fin ) 
           OR 
           (con.fecha_inicio <= tem.fecha_inicio AND con.fecha_fin >= tem.fecha_fin) ) 
          group by TEM.ID_TEMPORADA, COM.ID_PAIS, COM.ID_GENERO, COM.ID_MODALIDAD
     )  ;
       COMMIT;
       
       WRITE_LOG ( V_PROC, 'Fin del proceso sin errores', null, null, null, 'INFO'); 
       
EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      write_log ( 'P_EST_SUELDO_MEDIO ', NULL, ecode, emesg, null, 'ERROR');  
     
  END P_EST_SUELDO_MEDIO;
  
  PROCEDURE P_EST_MEJOR_JUGADOR_MUNDIAL
  as
  V_PROC    varchar2(32):='P_EST_MEJOR_JUGADOR_MUNDIAL';
  BEGIN
  
    WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
    
   DELETE FROM DATABASKET.EST_MEJOR_JUGADOR;
  COMMIT;
    -- TODO PARA CADA GENERO Y MODALIDAD
    
    INSERT INTO EST_MEJOR_JUGADOR
    SELECT ID_GENERO, ID_MODALIDAD, ID_JUGADOR
    FROM (
         SELECT 
        com.id_genero, com.id_modalidad, relest.id_jugador, NVL(sum(est.valoracion * tem.ponderacion )/count(*),0) total
         FROM competicion com, temporada tem,  partido par, rel_est_jug_par relest, estadistica est
         WHERE tem.id_competicion = com.id_competicion
         AND par.id_temporada = tem.id_temporada
         and tem.fecha_fin = (SELECT MAX(T2.FECHA_FIN) FECHA
                                        FROM temporada T2
                                       WHERE T2.ID_COMPETICION = tEM.id_competicion  
                                       --AND TO_CHAR(ADD_MONTHS(T2.FECHA_FIN,-12),'YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE,-12),'YYYY') 
                                       AND T2.FECHA_FIN between ADD_MONTHS(SYSDATE,-12) and sysdate 
                                       ) 
        and RELEST.ID_PARTIDO = PAR.ID_PARTIDO
        AND relest.id_estadistica = est.id_estadistica
        GROUP BY com.id_genero, com.id_modalidad, relest.id_jugador
        order by total desc
        )
        WHERE ROWNUM = 1
         ;
        COMMIT;
        
        WRITE_LOG ( V_PROC, 'Fin del proceso sin errores', null, null, null, 'INFO'); 
        
EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      write_log ( 'P_EST_MEJOR_JUGADOR_MUNDIAL ', NULL, ecode, emesg, null, 'ERROR');  
             
  END P_EST_MEJOR_JUGADOR_MUNDIAL;
  
  
  PROCEDURE P_EST_MEJORES_EQUIPOS 
  AS
  
    V_ID_COMPETICION  COMPETICION.ID_COMPETICION%TYPE;
    V_ID_TEMPORADA    TEMPORADA.ID_TEMPORADA%TYPE;
    
    V_ID_EQUIPO_OFE   EQUIPO.ID_EQUIPO%TYPE;
    V_ID_EQUIPO_DEF   EQUIPO.ID_EQUIPO%TYPE;
    
    V_PUNTOS      NUMBER;
    
    
    V_PROC    varchar2(30):='P_EST_MEJORES_EQUIPOS';
    
    V_SQL     VARCHAR2(4000);
  begin
   
   WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO'); 
   
   DELETE FROM DATABASKET.EST_MEJORES_EQUIPOS;
  COMMIT;

    insert into EST_MEJORES_EQUIPOS
        (ID_COMPETICION, ID_TEMPORADA, ID_EQUIPO_ATACANTE, ID_EQUIPO_DEFENSOR)
    select maxtable.ID_COMPETICION, maxtable.ID_TEMPORADA, maxtable.EQUIPO_OF, mintable.EQUIPO_DEF
      from 
      (
           select TT.ID_COMPETICION, TT.ID_TEMPORADA, TT.ID_EQUIPO EQUIPO_OF, NULL AS EQUIPO_DEF
            FROM 
            (SELECT tem.id_competicion, tem.id_temporada, rpar.id_equipo, sum(rpar.puntos) puntos
                    FROM temporada tem, partido par, vlk_resultado_partidos rpar
                  WHERE tem.id_temporada = par.id_temporada
                  and   PAR.ID_PARTIDO = RPAR.ID_PARTIDO
                  group by TEM.ID_COMPETICION, TEM.ID_TEMPORADA, RPAR.ID_EQUIPO) tt
            INNER JOIN
                (
                SELECT  id_temporada, MAX(puntos) AS Maxpuntos
                FROM 
                (SELECT tem.id_competicion, tem.id_temporada, rpar.id_equipo, sum(rpar.puntos) puntos
                    FROM temporada tem, partido par, vlk_resultado_partidos rpar
                  where TEM.ID_TEMPORADA = PAR.ID_TEMPORADA
                  and   PAR.ID_PARTIDO = RPAR.ID_PARTIDO
                  group by TEM.ID_COMPETICION, TEM.ID_TEMPORADA, RPAR.ID_EQUIPO)
                group by ID_TEMPORADA
                ) MAXTT on TT.ID_TEMPORADA = MAXTT.ID_TEMPORADA and TT.PUNTOS=MAXTT.MAXPUNTOS
        ) MAXTABLE
      inner join
          (              
          select TT.ID_COMPETICION, TT.ID_TEMPORADA, NULL EQUIPO_OF,TT.ID_EQUIPO EQUIPO_DEF
                    FROM 
                    (SELECT tem.id_competicion, tem.id_temporada, rpar.id_equipo, sum(rpar.puntos) puntos
                            FROM temporada tem, partido par, vlk_resultado_partidos rpar
                          WHERE tem.id_temporada = par.id_temporada
                          and   PAR.ID_PARTIDO = RPAR.ID_PARTIDO
                          group by TEM.ID_COMPETICION, TEM.ID_TEMPORADA, RPAR.ID_EQUIPO) tt
                    INNER JOIN
                        (
                        SELECT  id_temporada, MIN(puntos) AS Maxpuntos
                        FROM 
                        (SELECT tem.id_competicion, tem.id_temporada, rpar.id_equipo, sum(rpar.puntos) puntos
                            FROM temporada tem, partido par, vlk_resultado_partidos rpar
                          where TEM.ID_TEMPORADA = PAR.ID_TEMPORADA
                          and   PAR.ID_PARTIDO = RPAR.ID_PARTIDO
                          group by TEM.ID_COMPETICION, TEM.ID_TEMPORADA, RPAR.ID_EQUIPO)
                        group by ID_TEMPORADA
                        ) MAXTT on TT.ID_TEMPORADA = MAXTT.ID_TEMPORADA and TT.PUNTOS=MAXTT.MAXPUNTOS
              )MINTABLE on MINTABLE.ID_COMPETICION= MAXTABLE.ID_COMPETICION  and MINTABLE.ID_TEMPORADA= MAXTABLE.ID_TEMPORADA
          order by maxtable.ID_COMPETICION, maxtable.ID_TEMPORADA   ;
    COMMIT;
    
    
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'INFO'); 
    
EXCEPTION
  WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      write_log (V_PROC, NULL, ecode, emesg, V_SQL, 'ERROR');  
             
  END P_EST_MEJORES_EQUIPOS;  
END PKG_TRIGGERS;
/

create or replace 
PACKAGE PKG_CONTRATO AS 

  ECODE number;
  EMESG varchar2(200);
  
  procedure P_ALTA_CONTRATO (IN_FECHA_INICIO VARCHAR2,
                            IN_FECHA_FIN VARCHAR2,
                            IN_EQUIPO_COMPRADOR VARCHAR2,
                            IN_EQUIPO_VENDEDOR VARCHAR2,
                            IN_COMPENSACION VARCHAR2,
                            IN_SALARIO VARCHAR2,
                            IN_MONEDA VARCHAR2,
                            IN_JUGADOR varchar2,
                            OUT_RSP OUT varchar2);

  
  procedure P_BAJA_CONTRATO (IN_CONTRATO varchar2,
                            OUT_RSP OUT varchar2);
                            
  procedure P_MOD_CONTRATO (IN_CONTRATO varchar2,
                            IN_FECHA_INICIO VARCHAR2,
                            IN_FECHA_FIN VARCHAR2,
                            IN_EQUIPO_COMPRADOR VARCHAR2,
                            IN_EQUIPO_VENDEDOR VARCHAR2,
                            IN_COMPENSACION VARCHAR2,
                            IN_SALARIO VARCHAR2,
                            IN_MONEDA varchar2,
                            IN_JUGADOR varchar2,  
                            OUT_RSP OUT VARCHAR2);

END PKG_CONTRATO;
/
create or replace 
PACKAGE BODY PKG_CONTRATO AS

  procedure P_ALTA_CONTRATO (IN_FECHA_INICIO VARCHAR2,
                            IN_FECHA_FIN VARCHAR2,
                            IN_EQUIPO_COMPRADOR VARCHAR2,
                            IN_EQUIPO_VENDEDOR VARCHAR2,
                            IN_COMPENSACION VARCHAR2,
                            IN_SALARIO VARCHAR2,
                            IN_MONEDA varchar2,
                            IN_JUGADOR varchar2,
                            OUT_RSP OUT VARCHAR2) AS
    
   V_ERROR         NUMBER;

  E_ERROR_CONTROLADO  EXCEPTION;
  
  V_PROC    VARCHAR2(32):='P_ALTA_CONTRATO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_inicio (IN_FECHA_INICIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_fin (IN_FECHA_FIN);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación diferencia fechas
    V_ERROR:=pkg_validaciones.f_valida_fechas (IN_FECHA_INICIO, IN_FECHA_FIN);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo comprador
    V_ERROR:=pkg_validaciones.f_valida_equipo_comprador (IN_EQUIPO_COMPRADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación jugador
    V_ERROR:=pkg_validaciones.f_valida_JUGADOR (IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación jugador retirado
    V_ERROR:=pkg_validaciones.f_valida_JUGADOR_retirado (IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo vendedor
    V_ERROR:=pkg_validaciones.f_valida_equipo_vendedor (IN_EQUIPO_VENDEDOR, IN_FECHA_INICIO, IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación compensacion
    V_ERROR:=pkg_validaciones.f_valida_compensacion (IN_COMPENSACION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación salario
    V_ERROR:=pkg_validaciones.f_valida_salario (IN_SALARIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación moneda
    V_ERROR:=pkg_validaciones.f_valida_moneda (IN_MONEDA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
   
    
    insert into CONTRATO
    ( ID_CONTRATO, FECHA_INICIO, FECHA_FIN, ID_EQUIPO_COMPRADOR, ID_EQUIPO_VENDEDOR, 
      SALARIO, COMPENSACION, ID_MONEDA, ID_JUGADOR)
    values
    ( SEQ_CONTRATOS.NEXTVAL
    , TO_DATE(IN_FECHA_INICIO,'DD/MM/YYYY')
    , TO_DATE(IN_FECHA_FIN,'DD/MM/YYYY')
    , TO_NUMBER(IN_EQUIPO_COMPRADOR)
    , TO_NUMBER(IN_EQUIPO_VENDEDOR)
    , TO_NUMBER(IN_SALARIO)
    , TO_NUMBER(IN_COMPENSACION)
    , TO_NUMBER(IN_MONEDA)
    , TO_NUMBER(IN_JUGADOR)
    );
      
    
 commit;
 
    PKG_TRIGGERS.P_EST_MEJOR_PAGADO;
    PKG_TRIGGERS.P_EST_JUGADORES_ACTIVOS;
    PKG_TRIGGERS.P_EST_SUELDO_MEDIO;
    PKG_TRIGGERS.P_EST_MAYOR_GANANCIA;
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    
    OUT_RSP:='OK';
    
  EXCEPTION
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR');     
  END P_ALTA_CONTRATO;

  procedure P_BAJA_CONTRATO (IN_CONTRATO varchar2,
                            OUT_RSP OUT varchar2) AS
   V_ERROR         NUMBER;

  E_ERROR_CONTROLADO  EXCEPTION;
  
  V_PROC    VARCHAR2(32):='P_BAJA_CONTRATO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    -- Validación de contrato
    V_ERROR:=pkg_validaciones.f_valida_contrato (IN_CONTRATO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
  delete CONTRATO where ID_CONTRATO = IN_CONTRATO;
  commit;
  
  
    PKG_TRIGGERS.P_EST_MEJOR_PAGADO;
    PKG_TRIGGERS.P_EST_JUGADORES_ACTIVOS;
    PKG_TRIGGERS.P_EST_SUELDO_MEDIO;
    PKG_TRIGGERS.P_EST_MAYOR_GANANCIA;
  
  write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    
    OUT_RSP:='OK';
    
  EXCEPTION
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR');     
  END P_BAJA_CONTRATO;

  procedure P_MOD_CONTRATO (IN_CONTRATO varchar2,
                            IN_FECHA_INICIO VARCHAR2,
                            IN_FECHA_FIN VARCHAR2,
                            IN_EQUIPO_COMPRADOR VARCHAR2,
                            IN_EQUIPO_VENDEDOR VARCHAR2,
                            IN_COMPENSACION VARCHAR2,
                            IN_SALARIO VARCHAR2,
                            IN_MONEDA varchar2,
                            IN_JUGADOR varchar2,  
                            OUT_RSP OUT VARCHAR2) AS
     V_ERROR         NUMBER;

  E_ERROR_CONTROLADO  EXCEPTION;
  
  V_PROC    VARCHAR2(32):='P_MOD_CONTRATO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    -- Validación de contrato
    V_ERROR:=pkg_validaciones.f_valida_contrato (IN_CONTRATO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_inicio (IN_FECHA_INICIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_fin (IN_FECHA_FIN);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación diferencia fechas
    V_ERROR:=pkg_validaciones.f_valida_fechas (IN_FECHA_INICIO, IN_FECHA_FIN);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo comprador
    V_ERROR:=pkg_validaciones.f_valida_equipo_comprador (IN_EQUIPO_COMPRADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación jugador
    V_ERROR:=pkg_validaciones.f_valida_JUGADOR (IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    /*
    -- Validación jugador retirado
    V_ERROR:=pkg_validaciones.f_valida_JUGADOR_retirado (IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    */
    -- Validación equipo vendedor
    V_ERROR:=pkg_validaciones.f_valida_equipo_vendedor (IN_EQUIPO_VENDEDOR, IN_FECHA_INICIO, IN_JUGADOR);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación compensacion
    V_ERROR:=pkg_validaciones.f_valida_compensacion (IN_COMPENSACION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación salario
    V_ERROR:=pkg_validaciones.f_valida_salario (IN_SALARIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
     -- Validación moneda
    V_ERROR:=pkg_validaciones.f_valida_moneda (IN_MONEDA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
   
    
    update CONTRATO
    set
      FECHA_INICIO = TO_DATE(IN_FECHA_INICIO,'DD/MM/YYYY'),
      FECHA_FIN = TO_DATE(IN_FECHA_FIN,'DD/MM/YYYY'),
      ID_EQUIPO_COMPRADOR = TO_NUMBER(IN_EQUIPO_COMPRADOR),
      ID_EQUIPO_VENDEDOR = TO_NUMBER(IN_EQUIPO_VENDEDOR),
      SALARIO = TO_NUMBER(IN_SALARIO),
      COMPENSACION = TO_NUMBER(IN_COMPENSACION),
      ID_MONEDA = TO_NUMBER(IN_MONEDA),
      ID_JUGADOR = TO_NUMBER(IN_JUGADOR)
  where id_contrato = IN_CONTRATO;    
    
 commit;
 
    PKG_TRIGGERS.P_EST_MEJOR_PAGADO;
    PKG_TRIGGERS.P_EST_SUELDO_MEDIO;
    PKG_TRIGGERS.P_EST_MAYOR_GANANCIA;
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    
    OUT_RSP:='OK';
    
  EXCEPTION
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR');  
  END P_MOD_CONTRATO;

END PKG_CONTRATO;
/


create or replace 
PACKAGE PKG_ESTADISTICAS AS 

  ECODE number;
  EMESG varchar2(200);
  V_ERROR         number;
  E_ERROR_CONTROLADO  EXCEPTION; 

  
  FUNCTION F_JUGADORES_COMPETICION (IN_COMPETICION VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN t_est1type;
  
  FUNCTION F_PUNTUACIONES_COMPETICION (IN_COMPETICION VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN t_est2type;
  
  FUNCTION F_VALORADOS_POSICION (IN_AMBITO VARCHAR2, IN_GENERO VARCHAR2, IN_MODALIDAD VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN t_est3type;
  
  FUNCTION F_CONTRATOS_REPRESENTANTE (IN_REPRESENTANTE VARCHAR2, IN_ANIO VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST4TYPE;
  
  FUNCTION F_GASTOS_EQUIPOS (IN_ANIO VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST5TYPE;
  
  FUNCTION F_ULTIMO_CONTRATO (IN_PAIS VARCHAR2, IN_GENERO VARCHAR2, IN_MODALIDAD VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST6TYPE;
  
END PKG_ESTADISTICAS;
/

create or replace 
PACKAGE BODY PKG_ESTADISTICAS AS

/***
	NOMBRE: F_JUGADORES_COMPETICION
	PARAMETROS:
		ENTRADA:
			- Identificador de competicion
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 1
	DESCRIPCION:
		Devuelve el listado de todos los jugadores de la competición pasada por parametro.
		Incluye la fecha de finalización del ultimo contrato del jugador

**/
FUNCTION F_JUGADORES_COMPETICION (IN_COMPETICION VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN t_est1type
AS

  out_table t_est1type := t_est1type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 
  
  V_ID_JUGADOR NUMBER;
  V_NOMBRE VARCHAR2(255 CHAR); 
  V_APELLIDOS VARCHAR2(255 CHAR); 
  V_NACIONALIDAD VARCHAR2(255 CHAR); 
  V_FEDERACION varchar2(255 char); 
  V_NUMERO_FEDERADO VARCHAR2(15 CHAR);
  V_FECHA_NACIMIENTO DATE; 
  V_ALTURA NUMBER; 
  V_PESO NUMBER; 
  V_POSICION VARCHAR2(45 CHAR);
  V_URL_WEB VARCHAR2(255 CHAR); 
  V_URL_VIDEO VARCHAR2(255 CHAR); 
  V_ESTADO VARCHAR2(45 CHAR);
  V_ACTIVIDAD VARCHAR2(45 CHAR);
  V_GENERO VARCHAR2(45 CHAR);
  V_FECHA_FIN DATE;
  
	-- Cursor que devuelve los jugadores de una competición con la fecha de fin de su ultimo contrato
  
  cursor C_EST1 is
  SELECT JUG.ID_JUGADOR, JUG.NOMBRE, JUG.APELLIDOS, JUG.NACIONALIDAD, pais.desc_pais FEDERACION, JUG.NUMERO_FEDERADO, JUG.FECHA_NACIMIENTO, 
              JUG.ALTURA, JUG.PESO, pos.desc_posicion, JUG.URL_WEB, JUG.URL_VIDEO, EST.DESC_ESTADO, 
              act.desc_actividad, GEN.DESC_GENERO, CON.FECHA_fIN 
      FROM TEMPORADA TEM , rel_equipo_temporada REQ, contrato CON, 
            JUGADOR JUG, LKP_POSICION POS, LKP_PAIS PAIS, LKP_ESTADO EST, LKP_ACTIVIDAD ACT, LKP_GENERO GEN 
      WHERE TEM.id_competicion = IN_COMPETICION 
                  --- Ultima temporada
          AND tem.fecha_fin = (SELECT MAX(T2.FECHA_FIN) FECHA
                                 FROM temporada T2
                                 WHERE T2.ID_COMPETICION = tEM.id_competicion  ) 
        AND TEM.id_temporada  = req.id_temporada 
        AND con.id_equipo_comprador = req.id_equipo 
        -- Contrato vigente
        AND ( 
              (con.fecha_fin BETWEEN tem.fecha_inicio AND tem.fecha_fin) 
            OR 
              (con.fecha_inicio BETWEEN tem.fecha_inicio AND tem.fecha_fin ) 
            OR 
              (con.fecha_inicio <= tem.fecha_inicio AND con.fecha_fin >= tem.fecha_fin) ) 
        AND JUG.ID_JUGADOR = CON.ID_JUGADOR 
        -- Lookups
        AND JUG.ID_POSICION = POS.ID_POSICION 
        AND JUG.ID_ESTADO = EST.ID_ESTADO 
        AND JUG.ID_GENERO = GEN.ID_GENERO 
        AND JUG.FEDERACION = PAIS.ID_PAIS
        AND JUG.ID_ACTIVIDAD = ACT.ID_ACTIVIDAD;
  
  V_PROC    varchar2(32):='F_JUGADORES_COMPETICION';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación competicion
    V_ERROR:=pkg_validaciones.f_valida_competicion (IN_COMPETICION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
   
	-- Recogemos los valores de la consulta
  OPEN c_est1;
  LOOP
    FETCH C_EST1 into
    V_ID_JUGADOR, V_NOMBRE,  V_APELLIDOS,  V_NACIONALIDAD,  V_FEDERACION, V_NUMERO_FEDERADO, V_FECHA_NACIMIENTO, V_ALTURA, 
    V_PESO, V_POSICION, V_URL_WEB,  V_URL_VIDEO, V_ESTADO, V_ACTIVIDAD, V_GENERO, V_FECHA_FIN;
    EXIT WHEN C_EST1%NOTFOUND;
      out_table.extend;
      V_INDICE := V_INDICE + 1;
      out_table(v_indice) := est1type(V_ID_JUGADOR, V_NOMBRE,  V_APELLIDOS,  V_NACIONALIDAD,  V_FEDERACION, V_NUMERO_FEDERADO, V_FECHA_NACIMIENTO, V_ALTURA, 
    V_PESO, V_POSICION, V_URL_WEB,  V_URL_VIDEO, V_ESTADO, V_ACTIVIDAD, V_GENERO, V_FECHA_FIN);
    
  end loop;
  CLOSE c_est1;
  
  
    -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;

  -- Devolvemos el mensaje OK
  OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_JUGADORES_COMPETICION;

/***
	NOMBRE: F_PUNTUACIONES_COMPETICION
	PARAMETROS:
		ENTRADA:
			- Identificador de competicion
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 2
	DESCRIPCION:
		Devuelve el listado de todos los equipos de la competición pasada por parametro.
		La lista de equipos ha de estar ordenada por la cantidad de puntos a favor de la temporada actual

**/
FUNCTION F_PUNTUACIONES_COMPETICION (IN_COMPETICION VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN t_est2type
AS
  
  out_table t_est2type := t_est2type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 
  
  V_ULTIMA_TEMP     TEMPORADA.ID_TEMPORADA%TYPE;
  
  V_ID_EQUIPO       EQUIPO.ID_EQUIPO%tyPE;
  
  
  V_NOMBRE VARCHAR2(255 CHAR);
  V_PUNTUACION NUMBER;
  
   -- dada una temporada devolvemos la lista d eequipos ordenada por el total de sus puntos
  cursor C_PUNTUACIONES (P_ID_TEMPORADA number) is
  SELECT con.id_equipo_comprador, equ.nombre, sum(puntos)
      FROM partido part, rel_est_jug_par rel, estadistica est, contrato con, equipo equ
          WHERE part.id_temporada = P_id_temporada
            AND rel.ID_PARTIDO = PART.ID_PARTIDO
            and rel.id_estadistica = est.id_estadistica
            AND part.fecha_inicio BETWEEN con.fecha_inicio AND con.fecha_fin
            and con.id_jugador = rel.id_jugador
            and con.id_equipo_comprador = equ.id_equipo
        group by ID_EQUIPO_COMPRADOR, EQU.NOMBRE; 
        
  V_PROC    varchar2(32):='F_PUNTUACIONES_COMPETICION';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación competicion
    V_ERROR:=pkg_validaciones.f_valida_competicion (IN_COMPETICION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
	--Seleccionamos la ultima temporada de la competición
    SELECT ID_TEMPORADA
      INTO V_ULTIMA_TEMP
  from TEMPORADA TEM
      WHERE TEM.id_competicion = IN_COMPETICION
                  --- Ultima temporada
        AND tem.fecha_fin = (SELECT MAX(T2.FECHA_FIN) FECHA
                             FROM temporada T2
                              WHERE T2.ID_COMPETICION = tEM.id_competicion) ;
    
	-- Obtenemos el listado de equipos de la temporada
    OPEN c_puntuaciones(v_ultima_temp);
    LOOP
      FETCH C_PUNTUACIONES INTO  V_ID_EQUIPO, V_NOMBRE,  V_PUNTUACION ;
      EXIT WHEN C_PUNTUACIONES%NOTFOUND;
        out_table.extend;
        v_indice := v_indice + 1;
        out_table(v_indice) := est2type(V_ID_EQUIPO, V_NOMBRE,  V_PUNTUACION);
    END LOOP;

  -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;
    
  -- Devolvemos el mensaje OK
  OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_PUNTUACIONES_COMPETICION;
/***
	NOMBRE: F_VALORADOS_POSICION
	PARAMETROS:
		ENTRADA:
			- Identificador de ambito
			- Identificador de genero
			- Identificador de modalidad
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 3
	DESCRIPCION:
		Devuelve el listado de todos los equipos de la competición pasada por parametro.
		La lista de equipos ha de estar ordenada por la cantidad de puntos a favor de la temporada actual

**/
FUNCTION F_VALORADOS_POSICION (IN_AMBITO VARCHAR2, IN_GENERO VARCHAR2, IN_MODALIDAD VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST3TYPE
AS
  
  out_table t_est3type := t_est3type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 
  
  
  V_POSICION VARCHAR2(45 CHAR);
  V_ID_JUGADOR NUMBER;
  V_NOMBRE VARCHAR2(255 CHAR);
  V_APELLIDOS VARCHAR2(255 CHAR);
  V_MEDIA NUMBER;
  
    
  v_id_posicion lkp_posicion.id_posicion%type;
  
  
  CURSOR C_POSICIONES IS 
  SELECT ID_POSICION FROM LKP_POSICION;
  
	-- Devuelve los 5 mejores valorados de una posicion en concreto
  CURSOR C_VALORACIONES(P_ID_POSICION NUMBER) IS
  select pos.desc_posicion, jug2.id_jugador, jug2.nombre, jug2.apellidos, val.media
  from
    (
      SELECT rel.id_jugador, id_posicion, round(sum(valoracion_ponderada) / count(*),5) media
      FROM partido part, rel_est_jug_par rel, estadistica est, contrato con, jugador jug, competicion com, temporada tem
          WHERE com.id_ambito = IN_AMBITO
          and   com.id_genero = IN_GENERO
          AND   com.id_modalidad = IN_MODALIDAD
          and   tem.id_competicion = com.id_competicion
          AND   part.id_temporada = tem.id_temporada
            AND rel.ID_PARTIDO = PART.ID_PARTIDO
            and rel.id_estadistica = est.id_estadistica
            AND part.fecha_inicio BETWEEN con.fecha_inicio AND con.fecha_fin
            and con.id_jugador = rel.id_jugador
            and con.id_jugador = jug.id_jugador
            and jug.id_posicion = P_ID_POSICION
        group by rel.id_jugador, jug.id_posicion
        order by media desc
    )
    val, lkp_posicion pos, jugador jug2
    where val.id_jugador = jug2.id_jugador
    and val.id_posicion = pos.id_posicion
    and rownum <6
    order by val.id_posicion;     
 
 V_PROC    varchar2(32):='F_VALORADOS_POSICION';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación ambito
    V_ERROR:=pkg_validaciones.f_valida_ambito (IN_AMBITO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación genero
    V_ERROR:=pkg_validaciones.f_valida_genero (IN_GENERO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación modalidad
    V_ERROR:=pkg_validaciones.f_valida_modalidad (IN_MODALIDAD);

    if V_ERROR is not null then
      RAISE E_ERROR_CONTROLADO;
    end if;

	-- Obetemos las posiciones

  OPEN C_POSICIONES;
    LOOP
      FETCH C_POSICIONES INTO V_ID_POSICION;
      EXIT WHEN C_POSICIONES%NOTFOUND;
		-- Para cada una de las posiciones obtenemos sus 5 mejores jugadores
        open c_valoraciones(v_id_posicion);
        loop
          FETCH C_VALORACIONES INTO V_POSICION, V_ID_JUGADOR, V_NOMBRE, V_APELLIDOS, V_MEDIA;
          EXIT WHEN C_VALORACIONES%NOTFOUND;
            out_table.extend;
            v_indice := v_indice + 1;
            out_table(v_indice) := est3type(V_POSICION, V_ID_JUGADOR, V_NOMBRE, V_APELLIDOS, V_MEDIA);
        END LOOP;
        CLOSE C_VALORACIONES;
        
      END LOOP;
      
    CLOSE C_POSICIONES;
    
 -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;
  -- Devolvemos el mensaje OK  
   OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_VALORADOS_POSICION;
/***
	NOMBRE: F_CONTRATOS_REPRESENTANTE
	PARAMETROS:
		ENTRADA:
			- Identificador de representante de jugadores
			- año
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 4
	DESCRIPCION:
		Devuelve el numero y el importe de todos los contratos realizados por el representante pasado por parametro en el año indicado.

**/
FUNCTION F_CONTRATOS_REPRESENTANTE (IN_REPRESENTANTE VARCHAR2, IN_ANIO VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST4TYPE
AS
  out_table t_est4type := t_est4type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 
  
	-- Obtenemos la suma de de los contratos y el total de contratos
  cursor c_representante(REPRE NUMBER, ANIO NUMBER) is 
  SELECT sum(con.importe), count(*)
    FROM CONTRATO CON, REL_REP_JUGADOR REL
    WHERE TO_CHAR(CON.FECHA_INICIO,'YYYY') = ANIO
    AND   CON.ID_JUGADOR = REL.ID_JUGADOR
    and   rel.id_representante = REPRE
    AND  rel.fecha_inicio BETWEEN con.fecha_inicio and con.fecha_fin;
  
  V_IMPORTE_TOTAL     NUMBER;
  V_NUM_CONTRATOS     NUMBER;
  
 V_PROC    varchar2(32):='F_CONTRATOS_REPRESENTANTE';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación representante
    V_ERROR:=pkg_validaciones.f_valida_representante (IN_REPRESENTANTE);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación año
    V_ERROR:=pkg_validaciones.f_valida_anyo (IN_ANIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
	-- Obtenemos los reslutados para el representante y año
  open c_representante(IN_REPRESENTANTE, IN_ANIO);
        loop
          FETCH c_representante INTO V_IMPORTE_TOTAL, V_NUM_CONTRATOS;
          EXIT when C_REPRESENTANTE%NOTFOUND;
             -- Comprobamos que devuelve resultados
            if V_NUM_CONTRATOS = 0 then
              V_ERROR := -1067;
              RAISE E_ERROR_CONTROLADO;
            end if;
            
            out_table.extend;
            v_indice := v_indice + 1;
            out_table(v_indice) := est4type(V_IMPORTE_TOTAL, V_NUM_CONTRATOS);
        END LOOP;
        close C_REPRESENTANTE;
  
   -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;
  -- Devolvemos el mensaje OK   
   OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_CONTRATOS_REPRESENTANTE;
/***
	NOMBRE: F_GASTOS_EQUIPOS
	PARAMETROS:
		ENTRADA:
			- año
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 5
	DESCRIPCION:
		Devuelve el listado de los 10 equipos que más dinero se han gastado en el año pasado por parametro
		La lista de equipos ha de estar ordenada por la cantidad de puntos a favor de la temporada actual

**/

FUNCTION F_GASTOS_EQUIPOS (IN_ANIO VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST5TYPE
AS
out_table t_est5type := t_est5type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 
  
	-- Devuelve los 10 equipos que mas gasto han realizado en el año pasado por parametro
  cursor c_gastos(ANIO NUMBER) is 
      SELECT * 
      FROM 
      (SELECT con.id_equipo_comprador, EQUI.NOMBRE, round(sum(con.importe*mon.valor_euro),2)
      FROM CONTRATO CON, EQUIPO EQUI, LKP_MONEDA MON
      WHERE TO_CHAR(CON.FECHA_INICIO,'YYYY') = IN_ANIO
      AND CON.ID_EQUIPO_COMPRADOR = EQUI.ID_EQUIPO
      AND MON.ID_MONEDA = CON.ID_MONEDA
      GROUP BY CON.ID_EQUIPO_COMPRADOR, EQUI.NOMBRE
      ORDER BY SUM(CON.IMPORTE*mon.valor_euro) DESC)
      WHERE ROWNUM < 11;
  
  V_IMPORTE_TOTAL     NUMBER;
  v_nombre_equipo     EQUIPO.NOMBRE%TYPE;
  V_ID_EQUIPO         EQUIPO.ID_EQUIPO%type;
  
  V_PROC    varchar2(32):='F_GASTOS_EQUIPOS';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación representante
    V_ERROR:=pkg_validaciones.f_valida_ANYO (IN_ANIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
   -- Devuevle los resultados del listado
  open c_gastos(IN_ANIO);
        loop
          FETCH c_gastos INTO V_ID_EQUIPO, v_nombre_equipo, V_IMPORTE_TOTAL;
          EXIT WHEN c_gastos%NOTFOUND;
            out_table.extend;
            v_indice := v_indice + 1;
            out_table(v_indice) := est5type(V_ID_EQUIPO, v_nombre_equipo, V_IMPORTE_TOTAL);
        END LOOP;
        CLOSE c_gastos;
  
  -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;

  -- Devolvemos el mensaje OK   
   OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_GASTOS_EQUIPOS;

/***
	NOMBRE: F_ULTIMO_CONTRATO
	PARAMETROS:
		ENTRADA:
			- Identificador de pais
			- Identificador de genero
			- Identificador de modalidad
		SALIDA:
			- Resultado de la ejecución
		RETORNO:
			- Estructura de tipo 5
	DESCRIPCION:
		Devuelve el listado de los jugadores que acaban contrato al final de temporada actual.
		La competición de la temporada tiene que ser del genero, pais y modalidad pasadas por parametro
		La lista ha de incluir aquellos jugadores en activo que no tienen contrato.

**/

FUNCTION F_ULTIMO_CONTRATO (IN_PAIS VARCHAR2, IN_GENERO VARCHAR2, IN_MODALIDAD VARCHAR2, OUT_RSP OUT VARCHAR2) RETURN T_EST6TYPE
AS
out_table t_est6type := t_est6type();  -- Declare a local table structure and initialize it
  v_indice  NUMBER:=0; 

  V_ID_JUGADOR  JUGADOR.ID_JUGADOR%TYPE;
  V_NOMBRE      JUGADOR.NOMBRE%type;
  V_APELLIDOS   JUGADOR.APELLIDOS%TYPE;

  CURSOR C_CONTRATOS IS
	-- Jugadores que acaban contrato en la presente temporada
    select JUG.id_JUGADOR, JUG.NOMBRE, JUG.APELLIDOS
    from contrato con, temporada tem, competicion com, JUGADOR JUG
    where tem.id_competicion = com.id_competicion
    and   com.id_modalidad = IN_MODALIDAD
    and   sysdate between tem.fecha_inicio and tem.fecha_fin
    AND   con.fecha_fin BETWEEN tem.fecha_inicio AND tem.fecha_fin
    and   CON.ID_JUGADOR = JUG.ID_JUGADOR
    and   COM.ID_GENERO = IN_GENERO
    AND   JUG.FEDERACION = IN_PAIS
    UNION
	-- Jugadores sin contrato
    select ID_JUGADOR, JUG.NOMBRE, JUG.APELLIDOS from jugador JUG
    where JUG.FEDERACION = IN_PAIS
    AND JUG.ID_GENERO = IN_GENERO
    AND NOT EXISTS (SELECT NULL FROM CONTRATO CON 
                                WHERE sysdate between fecha_inicio and fecha_fin
                                 and CON.ID_JUGADOR = JUG.ID_JUGADOR);

 V_PROC    varchar2(32):='F_ULTIMO_CONTRATO';
  
  BEGIN
  
  WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'INFO');
  
  -- Validaciones
  
   -- Validación pais
    V_ERROR:=pkg_validaciones.f_valida_pais (IN_PAIS);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación pais
    V_ERROR:=pkg_validaciones.f_valida_genero (IN_GENERO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación pais
    V_ERROR:=pkg_validaciones.f_valida_modalidad (IN_MODALIDAD);

    if V_ERROR is not null then
      RAISE E_ERROR_CONTROLADO;
    end if;
	-- Generamos el listado
  open c_CONTRATOS;
        loop
          FETCH c_CONTRATOS INTO V_ID_JUGADOR, V_NOMBRE, V_APELLIDOS;
          EXIT WHEN c_CONTRATOS%NOTFOUND;
            out_table.extend;
            V_INDICE := V_INDICE + 1;
            out_table(v_indice) := est6type(V_ID_JUGADOR, V_NOMBRE, V_APELLIDOS);
        END LOOP;
        CLOSE c_CONTRATOS;

 -- Comprobamos que devuelve resultados
    if V_INDICE = 0 then
      V_ERROR := -1067;
      RAISE E_ERROR_CONTROLADO;
    end if;

  -- Devolvemos el mensaje OK   
   OUT_RSP:='OK';
  
  return OUT_TABLE;
  
EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
   when E_ERROR_CONTROLADO then
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      WRITE_LOG ( V_PROC, null, V_ERROR, OUT_RSP, null, 'ERROR');
      return null;
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      return null;
END F_ULTIMO_CONTRATO;
                             

END PKG_ESTADISTICAS;
/
create or replace 
PACKAGE PKG_JUGADOR AS 

  ecode NUMBER;
  emesg VARCHAR2(200);

  PROCEDURE P_ALTA_JUGADOR  (IN_NACIONALIDAD      VARCHAR2,
                      IN_FEDERACION        VARCHAR2,
                      IN_NUMERO_FEDERADO   VARCHAR2,
                      IN_NOMBRE            VARCHAR2, 
                      IN_APELLIDOS         VARCHAR2,
                      IN_FECHA_NACIMIENTO  VARCHAR2,
                      IN_ALTURA            VARCHAR2, 
                      IN_PESO              VARCHAR2,
                      IN_POSICION       VARCHAR2, 
                      IN_URL_WEB           VARCHAR2, 
                      IN_URL_VIDEO         VARCHAR2, 
                      IN_ESTADO         VARCHAR2,
                      IN_ACTIVIDAD      VARCHAR2,
                      IN_GENERO         VARCHAR2,
                      OUT_RSP            out  VARCHAR2) ;
                      
  procedure P_MODIFICAR_JUGADOR (IN_JUGADOR           VARCHAR2,
                      IN_NACIONALIDAD      VARCHAR2,
                      IN_FEDERACION        VARCHAR2,
                      IN_NUMERO_FEDERADO   VARCHAR2,
                      IN_NOMBRE            VARCHAR2, 
                      IN_APELLIDOS         VARCHAR2,
                      IN_FECHA_NACIMIENTO  VARCHAR2,
                      IN_ALTURA            VARCHAR2, 
                      IN_PESO              VARCHAR2,
                      IN_POSICION       VARCHAR2, 
                      IN_URL_WEB           VARCHAR2, 
                      IN_URL_VIDEO         VARCHAR2, 
                      IN_ESTADO         VARCHAR2,
                      IN_ACTIVIDAD      VARCHAR2,
                      IN_GENERO         varchar2,
                      OUT_RSP            OUT  varchar2);
                      
  procedure P_BAJA_JUGADOR   (IN_JUGADOR           varchar2,
                      OUT_RSP            OUT  varchar2);

END PKG_JUGADOR;
/
create or replace 
PACKAGE BODY PKG_JUGADOR AS

/***
	NOMBRE: P_ALTA_JUGADOR 
	PARAMETROS:
		ENTRADA:
			- Nacionalidad
			- Identificador de pais
			- Numero federado
			- Nombre
			- Apellidos
			- Fecha de nacimiento
			- Altura
			- Peso
			- Identificador de posicion
			- Url web
			- Url video promocional
			- Identificador de estado
			- Identificador de actividad
			- Identificador de genero

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Valida los parametros de entrada e inserta un nuevo jugador en la BD

**/

  PROCEDURE P_ALTA_JUGADOR  (IN_NACIONALIDAD      VARCHAR2,
                      IN_FEDERACION        VARCHAR2,
                      IN_NUMERO_FEDERADO   VARCHAR2,
                      IN_NOMBRE            VARCHAR2, 
                      IN_APELLIDOS         VARCHAR2,
                      IN_FECHA_NACIMIENTO  VARCHAR2,
                      IN_ALTURA            VARCHAR2, 
                      IN_PESO              VARCHAR2,
                      IN_POSICION       VARCHAR2, 
                      IN_URL_WEB           VARCHAR2, 
                      IN_URL_VIDEO         VARCHAR2, 
                      IN_ESTADO         VARCHAR2,
                      IN_ACTIVIDAD      VARCHAR2,
                      IN_GENERO         VARCHAR2,
                      OUT_RSP            out  VARCHAR2)   AS
  V_ERROR         NUMBER;

  E_ERROR_CONTROLADO  EXCEPTION;
  
  V_PROC    VARCHAR2(32):='P_ALTA_JUGADOR';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    
    -- Check nacionalidad
    V_ERROR:=pkg_validaciones.f_valida_nacionalidad (IN_NACIONALIDAD);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Check federacion
    V_ERROR:=pkg_validaciones.f_valida_federacion (IN_FEDERACION);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
   
    -- Check numero federado
    V_ERROR:=pkg_validaciones.f_valida_num_federado (IN_NUMERO_FEDERADO, IN_FEDERACION);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Check nombre
    V_ERROR:=pkg_validaciones.f_valida_nombre (IN_NOMBRE );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
     -- Check apellidos    
    V_ERROR:=pkg_validaciones.f_valida_apellido (IN_APELLIDOs );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Check nombre y apellidos    
    V_ERROR:=pkg_validaciones.f_valida_fecha_nacimiento (IN_FECHA_NACIMIENTO );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
         
    -- Validación altura    
    V_ERROR:=pkg_validaciones.f_valida_altura (IN_ALTURA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Validación peso
    V_ERROR:=pkg_validaciones.f_valida_peso (IN_PESO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación posicion
    V_ERROR:=pkg_validaciones.f_valida_posicion (IN_POSICION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación estado
    V_ERROR:=pkg_validaciones.f_valida_estado (IN_ESTADO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
     -- Validación actividad
    V_ERROR:=pkg_validaciones.f_valida_actividad (IN_ACTIVIDAD);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
      -- Validación genero
    V_ERROR:=pkg_validaciones.f_valida_genero (IN_GENERO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
	-- Insertamos el jugador
    INSERT INTO JUGADOR 
    (ID_JUGADOR, NACIONALIDAD ,FEDERACION ,NUMERO_FEDERADO ,NOMBRE 
      ,APELLIDOS ,FECHA_NACIMIENTO ,ALTURA ,PESO ,ID_POSICION ,URL_WEB 
      ,URL_VIDEO ,ID_ESTADO ,ID_ACTIVIDAD, ID_GENERO)
    VALUES
    (SEQ_JUGADORES.NEXTVAL
    ,IN_NACIONALIDAD     
    ,TO_NUMBER(IN_FEDERACION)
    ,IN_NUMERO_FEDERADO  
    ,IN_NOMBRE           
    ,IN_APELLIDOS        
    ,TO_DATE(IN_FECHA_NACIMIENTO,'DD/MM/YYYY')
    ,TO_NUMBER(IN_ALTURA)
    ,TO_NUMBER(IN_PESO)
    ,TO_NUMBER(IN_POSICION)
    ,IN_URL_WEB
    ,IN_URL_VIDEO
    ,TO_NUMBER(IN_ESTADO)    
    ,TO_NUMBER(IN_ACTIVIDAD)
    ,TO_NUMBER(IN_GENERO)
    );
      
    commit;
   
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK   
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
  END P_ALTA_JUGADOR;

/***
	NOMBRE: P_MODIFICAR_JUGADOR 
	PARAMETROS:
		ENTRADA:
			- Identificador de jugador
			- Nacionalidad
			- Identificador de pais
			- Numero federado
			- Nombre
			- Apellidos
			- Fecha de nacimiento
			- Altura
			- Peso
			- Identificador de posicion
			- Url web
			- Url video promocional
			- Identificador de estado
			- Identificador de actividad
			- Identificador de genero

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Valida los parametros de entrada y modifica un jugador en la BD

**/  

  
  procedure P_MODIFICAR_JUGADOR (IN_JUGADOR           VARCHAR2,
                      IN_NACIONALIDAD      VARCHAR2,
                      IN_FEDERACION        VARCHAR2,
                      IN_NUMERO_FEDERADO   VARCHAR2,
                      IN_NOMBRE            VARCHAR2, 
                      IN_APELLIDOS         VARCHAR2,
                      IN_FECHA_NACIMIENTO  VARCHAR2,
                      IN_ALTURA            VARCHAR2, 
                      IN_PESO              VARCHAR2,
                      IN_POSICION       VARCHAR2, 
                      IN_URL_WEB           VARCHAR2, 
                      IN_URL_VIDEO         VARCHAR2, 
                      IN_ESTADO         VARCHAR2,
                      IN_ACTIVIDAD      VARCHAR2,
                      IN_GENERO         varchar2,
                      OUT_RSP            out  VARCHAR2)   AS
  
  V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION;
  V_PROC    VARCHAR2(32):='P_MODIFICAR_JUGADOR';
  BEGIN
     write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    
    -- Check jugador
     V_ERROR:=pkg_validaciones.f_valida_jugador (IN_JUGADOR);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Check nacionalidad
    V_ERROR:=pkg_validaciones.f_valida_nacionalidad (IN_NACIONALIDAD);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Check federacion
    V_ERROR:=pkg_validaciones.f_valida_federacion (IN_FEDERACION);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    

    -- Check numero federado duplicado
    V_ERROR:=pkg_validaciones.f_valida_num_federado_dup (IN_JUGADOR, IN_NUMERO_FEDERADO, IN_FEDERACION);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Check nombre
    V_ERROR:=pkg_validaciones.f_valida_nombre (IN_NOMBRE );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
     -- Check apellidos    
    V_ERROR:=pkg_validaciones.f_valida_apellido (IN_APELLIDOs );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    
    -- Check fecha nacimiento 
    V_ERROR:=pkg_validaciones.f_valida_fecha_nacimiento (IN_FECHA_NACIMIENTO );
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
         
    -- Validación altura    
    V_ERROR:=pkg_validaciones.f_valida_altura (IN_ALTURA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
    -- Validación peso
    V_ERROR:=pkg_validaciones.f_valida_peso (IN_PESO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación posicion
    V_ERROR:=pkg_validaciones.f_valida_posicion (IN_POSICION);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación estado
    V_ERROR:=pkg_validaciones.f_valida_estado (IN_ESTADO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
     -- Validación actividad
    V_ERROR:=pkg_validaciones.f_valida_actividad (IN_ACTIVIDAD);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
      -- Validación genero
    V_ERROR:=pkg_validaciones.f_valida_genero (IN_GENERO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    END IF;
    
	-- Actualizamos el jugador
    update JUGADOR 
    SET   
      NACIONALIDAD = IN_NACIONALIDAD,
      FEDERACION = TO_NUMBER(IN_FEDERACION),
      NUMERO_FEDERADO = IN_NUMERO_FEDERADO,
      NOMBRE = IN_NOMBRE,
      APELLIDOS = IN_APELLIDOS,
      FECHA_NACIMIENTO = TO_DATE(IN_FECHA_NACIMIENTO,'DD/MM/YYYY'),
      ALTURA = IN_ALTURA,
      PESO = IN_PESO,
      ID_POSICION = IN_POSICION,
      URL_WEB = IN_URL_WEB,
      URL_VIDEO = IN_URL_VIDEO,
      ID_ESTADO = TO_NUMBER(IN_ESTADO),
      ID_ACTIVIDAD = TO_NUMBER(IN_ACTIVIDAD),
      ID_GENERO = TO_NUMBER(IN_GENERO)
    WHERE ID_JUGADOR = IN_JUGADOR;
      
    commit;
    
    -- Actualizacion del modulo estadistico
    PKG_TRIGGERS.P_EST_JUGADORES_ACTIVOS;
   
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK   
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      
  END P_MODIFICAR_JUGADOR;

/***
	NOMBRE: P_BAJA_JUGADOR 
	PARAMETROS:
		ENTRADA:
			- Identificador de jugador

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Elimina un jugador en la BD

**/  
  procedure P_BAJA_JUGADOR   (IN_JUGADOR           VARCHAR2,
                      OUT_RSP            OUT  varchar2)    as

  V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION;
  V_PROC    VARCHAR2(32):='P_BAJA_JUGADOR';                      
                      
  BEGIN
  
    WRITE_LOG ( V_PROC, 'Inicio del proceso', null, null, null, 'TRACE'); 
    
    -- Check jugador
     V_ERROR:=pkg_validaciones.f_valida_jugador (IN_JUGADOR);
    
    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;

   -- Eliminamos al jugador 
   DELETE JUGADOR WHERE ID_JUGADOR = IN_JUGADOR;
    
   commit;
   
   -- Actualizacion del modulo estadistico
    PKG_TRIGGERS.P_EST_JUGADORES_ACTIVOS;
    PKG_TRIGGERS.P_EST_MAXIMO_ANOTADOR;
    PKG_TRIGGERS.P_EST_MAYOR_GANANCIA;
    PKG_TRIGGERS.P_EST_MEJOR_JUGADOR_MUNDIAL;
    PKG_TRIGGERS.P_EST_MEJOR_PAGADO;
    PKG_TRIGGERS.P_EST_MEJORES_EQUIPOS;
    PKG_TRIGGERS.P_EST_SUELDO_MEDIO;
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 

    -- Devolvemos el mensaje OK       
    OUT_RSP:='OK';
    
    
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      emesg := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
      
  END P_BAJA_JUGADOR;

END PKG_JUGADOR;
/
create or replace 
package PKG_PARTIDO as 

  ECODE number;
  EMESG varchar2(200);

  
  procedure P_ALTA_PARTIDO( IN_FECHA_INICIO VARCHAR2, 
                            IN_EQUIPO_LOCAL varchar2, 
                            IN_EQUIPO_VISITANTE varchar2, 
                            IN_TEMPORADA varchar2,
                            OUT_RSP OUT varchar2);

  procedure P_BAJA_PARTIDO(IN_PARTIDO varchar2,
                          OUT_RSP OUT varchar2);
                          
  procedure P_MOD_PARTIDO ( IN_PARTIDO varchar2,
                            IN_FECHA_INICIO VARCHAR2, 
                            IN_EQUIPO_LOCAL varchar2, 
                            IN_EQUIPO_VISITANTE varchar2, 
                            IN_TEMPORADA varchar2,
                            OUT_RSP OUT varchar2);
  procedure P_CONVOCADOS (  IN_PARTIDO varchar2,
                            IN_JUGADOR VARCHAR2, 
                            OUT_RSP OUT varchar2);

  procedure P_ARBITROS (IN_PARTIDO varchar2,
                        IN_ARBITRO varchar2,
                        IN_ROL varchar2,
                        OUT_RSP OUT varchar2);

END PKG_PARTIDO;
/

create or replace 
PACKAGE BODY PKG_PARTIDO AS

/***
	NOMBRE: P_ALTA_PARTIDO 
	PARAMETROS:
		ENTRADA:
			- Fecha del partido
			- Identificador equipo local
			- Identificador equipo visitante
			- Identificador temporada

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Añade un partido a la BD

**/ 

  procedure P_ALTA_PARTIDO( IN_FECHA_INICIO VARCHAR2, 
                            IN_EQUIPO_LOCAL varchar2, 
                            IN_EQUIPO_VISITANTE varchar2, 
                            IN_TEMPORADA varchar2,
                            OUT_RSP OUT varchar2) AS

   V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION; 
  V_PROC    VARCHAR2(32):='P_ALTA_PARTIDO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_inicio (IN_FECHA_INICIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo local
    V_ERROR:=pkg_validaciones.f_valida_equipo_local (IN_EQUIPO_LOCAL);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo visitante
    V_ERROR:=pkg_validaciones.f_valida_equipo_visitante (IN_EQUIPO_VISITANTE);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación temporada
    V_ERROR:=pkg_validaciones.f_valida_temporada (IN_TEMPORADA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    
    -- Validación fecha inicio dentro de temporada
    V_ERROR:=pkg_validaciones.f_valida_fecha_temporada (IN_FECHA_INICIO, IN_TEMPORADA);

    if V_ERROR is not null then
      RAISE E_ERROR_CONTROLADO;
    end if;
    
	-- Insertamos el partido
    
    insert into PARTIDO
    ( ID_PARTIDO, FECHA_INICIO, ID_EQUIPO_LOCAL, ID_EQUIPO_VISITANTE, ID_TEMPORADA)
    values
    ( SEQ_PARTIDOS.NEXTVAL
    , TO_DATE(IN_FECHA_INICIO,'DD/MM/YYYY')
    , TO_NUMBER(IN_EQUIPO_LOCAL)
    , TO_NUMBER(IN_EQUIPO_VISITANTE)
    , TO_NUMBER(IN_TEMPORADA)
    );
      
    
 commit;
 
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK  
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
    
   
  END P_ALTA_PARTIDO;

/***
	NOMBRE: P_BAJA_PARTIDO 
	PARAMETROS:
		ENTRADA:
			- Identificador de partido

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Elimina un partido en la BD

**/  
  procedure P_BAJA_PARTIDO(IN_PARTIDO varchar2,
                          OUT_RSP OUT varchar2) AS
 
  V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION;
  V_PROC    VARCHAR2(32):='P_BAJA_PARTIDO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'INFO'); 
    
    -- Validación de contrato
    V_ERROR:=pkg_validaciones.f_valida_partido (IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
	-- Borramos el partido
  delete PARTIDO where ID_PARTIDO = IN_PARTIDO;
  commit;
  
	-- Actualizamos las estadisticas afectadas
  
    PKG_TRIGGERS.P_EST_MAXIMO_ANOTADOR;
    PKG_TRIGGERS.P_EST_MEJOR_JUGADOR_MUNDIAL;
    PKG_TRIGGERS.P_EST_MEJORES_EQUIPOS;
  
  write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'INFO'); 
    -- Devolvemos el mensaje OK  
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR');
   
  END P_BAJA_PARTIDO;
  
/***
	NOMBRE: P_MOD_PARTIDO 
	PARAMETROS:
		ENTRADA:
			- Identificador de partido
			- Fecha del partido
			- Identificador equipo local
			- Identificador equipo visitante
			- Identificador temporada

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Modifica un partido de la BD

**/ 

  procedure P_MOD_PARTIDO ( IN_PARTIDO varchar2,
                            IN_FECHA_INICIO VARCHAR2, 
                            IN_EQUIPO_LOCAL varchar2, 
                            IN_EQUIPO_VISITANTE varchar2, 
                            IN_TEMPORADA varchar2,
                            OUT_RSP OUT varchar2) AS

    V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION; 
  V_PROC    VARCHAR2(32):='P_ALTA_PARTIDO';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'TRACE'); 
    
    
     -- Validación partido
    V_ERROR:=pkg_validaciones.f_valida_partido (IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    
    -- Validación fecha inicio
    V_ERROR:=pkg_validaciones.f_valida_fecha_inicio (IN_FECHA_INICIO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo local
    V_ERROR:=pkg_validaciones.f_valida_equipo_local (IN_EQUIPO_LOCAL);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación equipo visitante
    V_ERROR:=pkg_validaciones.f_valida_equipo_visitante (IN_EQUIPO_VISITANTE);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación temporada
    V_ERROR:=pkg_validaciones.f_valida_temporada (IN_TEMPORADA);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    
    -- Validación fecha inicio dentro de temporada
    V_ERROR:=pkg_validaciones.f_valida_fecha_temporada (IN_FECHA_INICIO, IN_TEMPORADA);

    if V_ERROR is not null then
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Modificacion del partido
    
    update PARTIDO
    set FECHA_INICIO = TO_DATE(IN_FECHA_INICIO,'DD/MM/YYYY')
    , ID_EQUIPO_LOCAL = IN_EQUIPO_LOCAL
    , ID_EQUIPO_VISITANTE =IN_EQUIPO_VISITANTE
    , ID_TEMPORADA = IN_TEMPORADA
    
    WHERE ID_PARTIDO = IN_PARTIDO;

     commit;
 
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK  
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
  END P_MOD_PARTIDO;
  
  /***
	NOMBRE: P_CONVOCADOS 
	PARAMETROS:
		ENTRADA:
			- Identificador de partido
			- Identificador jugador

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Añade un jugador a la lista de convocados de un partido

**/ 
  

  procedure P_CONVOCADOS (  IN_PARTIDO varchar2,
                            IN_JUGADOR VARCHAR2, 
                            OUT_RSP OUT varchar2) AS
   V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION; 
  V_PROC    VARCHAR2(32):='P_CONVOCADOS';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'INFO'); 
    
    -- Validación PARTIDO
    V_ERROR:=pkg_validaciones.f_valida_partido (IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación JUGADOR
    V_ERROR:=pkg_validaciones.f_valida_jugador_convocado (IN_JUGADOR, IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Añadimos la relacion de jugador-partido
    insert into REL_JUGADOR_PARTIDO
    ( ID_PARTIDO, ID_JUGADOR)
    values
    ( IN_PARTIDO, IN_JUGADOR);

   commit;
 
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK  
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 
    

  END P_CONVOCADOS;
  
  /***
	NOMBRE: P_ARBITROS 
	PARAMETROS:
		ENTRADA:
			- Identificador de partido
			- Identificador arbitro
			- Identificador de rol de arbitro

		SALIDA:
			- Resultado de la ejecución

	DESCRIPCION:
		Añade un arbitro al equipo arbitral de un partido

**/ 
  procedure P_ARBITROS (IN_PARTIDO varchar2,
                        IN_ARBITRO varchar2,
                        IN_ROL varchar2,
                        OUT_RSP OUT varchar2) AS
  
  V_ERROR         NUMBER;
  E_ERROR_CONTROLADO  EXCEPTION; 
  V_PROC    VARCHAR2(32):='P_ARBITROS';
  
  BEGIN
  
    write_log ( V_PROC, 'Inicio del proceso', NULL, NULL, NULL, 'INFO'); 
    
    -- Validación PARTIDO
    V_ERROR:=pkg_validaciones.f_valida_partido (IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
      
    -- Validación rol arbitro
    V_ERROR:=pkg_validaciones.f_valida_rol_arbitro (IN_ROL);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
    
    -- Validación arbitro
    V_ERROR:=pkg_validaciones.f_valida_arbitro (IN_ARBITRO, IN_PARTIDO);

    IF V_ERROR IS NOT NULL THEN
      RAISE E_ERROR_CONTROLADO;
    end if;
  
	-- Insertamos el arbitro y el rol al partido
    insert into REL_ARB_PARTIDO
    ( ID_PARTIDO, ID_ARBITRO, ID_ROL)
    values
    ( IN_PARTIDO, IN_ARBITRO,IN_ROL );

   commit;
 
    
    write_log ( V_PROC, 'Fin del proceso sin errores', NULL, NULL, NULL, 'TRACE'); 
    -- Devolvemos el mensaje OK  
    OUT_RSP:='OK';
    
  EXCEPTION
	-- Si es un error esperado, anotamos el mensaje propio del error
    WHEN E_ERROR_CONTROLADO THEN
      SELECT desc_error INTO OUT_RSP FROM lkp_errores WHERE id_error = V_ERROR;
      write_log ( V_PROC, NULL, V_ERROR, OUT_RSP, NULL, 'ERROR');
	-- Si es un error inseperado, anotamos el mensaje estandar
    WHEN OTHERS THEN
      ecode := SQLCODE;
      EMESG := SQLERRM;
      WRITE_LOG ( V_PROC, null, ECODE, EMESG, null, 'ERROR'); 

  END P_ARBITROS;


END PKG_PARTIDO;
/


